angular.module('LoanApplication.controllers', [])

    .controller('GlobalController', function($scope, $state, $ionicHistory, $cordovaSplashscreen, $cordovaKeyboard, $ionicViewSwitcher, $ionicScrollDelegate, $ionicConfig, $window, $ionicLoading, $timeout, $http, config) {
        $scope.config = config;

        $scope.appUpdate = function(){
            if (typeof chcp === 'undefined'){return;}
            chcp.fetchUpdate(function(error, data){
                if (!error){
                    chcp.installUpdate(function(e){
                        // $cordovaSplashscreen.show();
                        // $timeout(function () {
                        //     if ($cordovaSplashscreen && navigator.splashscreen){
                        //         $cordovaSplashscreen.hide();
                        //     }
                        // }, 2000);
                    });
                }
            });
        };

        $scope.focusHidden = function(){
            $scope.Tips.hide();
            if (typeof cordova != 'undefined' && $cordovaKeyboard){
                $cordovaKeyboard.close();
            }
            $scope.focusScroll.onKeyboradHide();
        };

        $scope.focusScroll = {};
        $scope.focusScroll.scroll = '';
        $scope.focusScroll.gapHeight = 0;
        $scope.focusScroll.keyboardHeight = 0;
        $scope.focusScroll.windowHeight = window.screen.height;

        $scope.focusScroll.elementY = 0;
        $scope.focusScroll.onKeyboradShow = function(keyboardHeight){
            if ($scope.isValid($scope.focusScroll.scroll)){
                $scope.focusScroll.keyboardHeight = keyboardHeight;
                $timeout(function () {
                    $ionicScrollDelegate.$getByHandle($scope.focusScroll.scroll).scrollBy(0, $scope.focusScroll.gapHeight*2, true);
                }, 100);
            }
        };
        $scope.focusScroll.onKeyboradHide = function(){
            $scope.focusScroll.scroll = '';
            $scope.focusScroll.gapHeight = 0;
            $scope.focusScroll.elementY = 0;
            $scope.focusScroll.keyboardHeight = 0;
        };
        $scope.focusScroll.getTop = function(e){
            var offset = e.offsetTop;
            if($scope.isValid(e.offsetParent)){ offset += $scope.focusScroll.getTop(e.offsetParent);}
            return offset;
        };
        $scope.focusScroll.registor = function(event, scroll, gapHeight){
            var e = window.event || event;
            $scope.focusScroll.elementY = $scope.focusScroll.getTop(e.target);
            $scope.focusScroll.scroll = scroll;
            $scope.focusScroll.gapHeight = gapHeight + e.target.height;
            $timeout(function () {
                e.target.focus();
            }, 100);
            // $timeout(function () {
            //     $ionicScrollDelegate.$getByHandle($scope.focusScroll.scroll).scrollBy(0, $scope.focusScroll.gapHeight, true);
            // }, 100);
        };
        window.addEventListener('native.keyboardshow', function keyboardShowHandler(e){
            $scope.focusScroll.onKeyboradShow(e.keyboardHeight);
        });
        window.addEventListener('native.keyboardhide', function keyboardShowHandler(e){
            $scope.focusScroll.onKeyboradHide();
        });

        $scope.isValid = function(object){
            if (angular.isUndefined(object)){return false;}
            if (!object){return false;}
            if (object===0){return false;}
            if (angular.isString(object)){return object.trim().length>0;}
            if (angular.isNumber(object)){return object!==0;}
            if (angular.isArray(object)){return object.length>0;}
            return object;
        };

        $scope.loop = {};
        $scope.loop.list = {};
        $scope.loop.removeAllLoop = function(){
            for(var item in $scope.loop.list){
                $scope.loop.removeLoop(item);
            }
        };
        $scope.loop.pauseAllLoop = function(){
            for(var item in $scope.loop.list){
                $scope.loop.pauseLoop(item);
            }
        };
        $scope.loop.resumeAllLoop = function(){
            for(var item in $scope.loop.list){
                $scope.loop.resumeLoop(item);
            }
        };
        $scope.loop.removeLoop = function(key){
            if (!$scope.isValid($scope.loop.list[key])){
                return;
            }
            $scope.loop.list[key].paused = true;
            $timeout.cancel($scope.loop.list[key].timer);
            $scope.loop.list[key] = null;
        };
        $scope.loop.pauseLoop = function(key){
            if (!$scope.isValid($scope.loop.list[key])){
                return;
            }
            $scope.loop.list[key].paused = true;
        };
        $scope.loop.resumeLoop = function(key){
            if (!$scope.isValid($scope.loop.list[key])){
                $scope.loop.list[key] = {};
            }
            $scope.loop.list[key].paused = false;
            $scope.loop.addLoop(key, $scope.loop.list[key].func, $scope.loop.list[key].time);
        };
        $scope.loop.run = function(key, func, time) {
            if ($scope.loop.list[key].paused){return;}
            $scope.loop.list[key].timer = $timeout(function() {
                if ($scope.isValid(func)){func();}
                $scope.loop.run(key, func, time);
            }, time);
        };
        $scope.loop.addLoop = function(key, func, time) {
            $scope.loop.removeLoop(key);
            $scope.loop.list[key] = {};
            $scope.loop.list[key].paused = false;
            $scope.loop.list[key].func = func;
            $scope.loop.list[key].time = time;
            $scope.loop.list[key].timer = '';
            $scope.loop.run(key, func, time);
        };

        $scope.preventEvent = function(event){
            var e = window.event || event;
            e.preventDefault();
            e.stopPropagation();
        };

        $scope.copyData = function(args){
            $scope.Tips.show(1000, '已复制:'+args, null);
        };

        $scope.doBack = function(disableIndex) {
            $scope.Tips.hide();
            if ($ionicHistory.backView()) {
                $ionicHistory.goBack();
            }else{
                if (disableIndex){
                    $scope.goUrl('index', {}, false, true);
                }
            }
        };
        $scope.goUrl = function(url, obj, isShow, isAnimate) {
            $scope.appUpdate(-1);

            if (!isShow){
                $scope.Tips.hide();
            }
            if (!$scope.isValid(url)){
                $state.go('index');
            }else{
                // $ionicHistory.nextViewOptions({
                //     disableAnimate: $scope.isValid(isAnimate) && config.isApple
                // });
                if ($scope.isValid(isAnimate) && config.isApple){
                    $ionicViewSwitcher.nextDirection("forwoard");
                }
                if ($scope.isValid(obj) && $scope.isValid(obj.reload)){
                    obj.rand = new Date().getTime();
                }
                $state.go(url, obj);
            }
        };

        // $scope.config.init($scope, $cordovaDevice, $ionicConfig, $window, config);

        $scope.Tips = {};
        $scope.Tips.status = false;
        $scope.Tips.content = '';
        $scope.Tips.show = function (time, content, callback){
            if (time>0){
                $ionicLoading.hide();
                $scope.Tips.status = true;
                $scope.Tips.content = content;
                $timeout(function() {
                    $scope.Tips.status = false;
                    if ($scope.isValid(callback)){callback();}
                }, time);
            }else{
                if ($scope.isValid(callback)){callback();}
            }
        };

        $scope.Tips.hide = function(){
            $scope.Tips.status = false;
        };

        $scope.getTokening = false;
        $scope.getToken = function(response){
            if (!$scope.getTokening) {
                $scope.getTokening = true;
                if (!$scope.isValid(response)) {
                    var params = {};
                    params.app_product_key = config.app_product_key;

                    $http({
                        timeout: 10000,
                        method: 'jsonp',
                        url: config.data_domain + "/index.php/index/token?callback=JSON_CALLBACK",
                        params: params
                    })
                    .success(function (response) {
                        if (response.success) {
                            config[config.TOKEN_NAME] = response[config.TOKEN_NAME];
                        }
                        $scope.getTokening = false;
                    })
                    .error(function (response, status) {
                        $scope.getTokening = false;
                        // $scope.Tips.show(2000, '网络不可用，请检查您的网络设置', null);
                    })
                    .finally(function() {
                        $scope.getTokening = false;
                    })
                    ;
                }
            }

            if ($scope.isValid(response) && $scope.isValid(response[config.TOKEN_NAME])){
                config[config.TOKEN_NAME] = response[config.TOKEN_NAME];
            }
            return config[config.TOKEN_NAME];
        };
    })

    .controller('NumberKeyboardController', function($scope, $timeout, config) {
        $scope.NumberKeyboard = {};
        $scope.NumberKeyboard.status = false;

        $scope.NumberKeyboard.beforeString = "";
        $scope.NumberKeyboard.currentString = "";

        // $scope.NumberKeyboard.miniScreen = 350/221*window.screen.width/4+400>window.screen.height;
        // if ($scope.isValid($scope.NumberKeyboard.miniScreen)){
        //     $scope.NumberKeyboard.keyborad_button_height = window.screen.height*0.21;
        // }else{
        //     $scope.NumberKeyboard.keyborad_button_height = 350/221*window.screen.width/4;
        // }
        // $scope.NumberKeyboard.height = $scope.NumberKeyboard.keyborad_button_height*4-2;
        // $scope.NumberKeyboard.width = window.screen.width*2;
        $scope.NumberKeyboard.x = 0;
        $scope.NumberKeyboard.y = window.screen.height*0.4;
        $scope.NumberKeyboard.windowHeight = window.screen.height;

        $scope.NumberKeyboard.doInput = function(keyString){
            // if(keyString==="\b"){//清除键
            //     keyString = "\b";
            // }else
            // }else{//1-9键
            if(keyString==="\r"){// .键
                $scope.NumberKeyboard.finishInput();
                return;
            }else if(keyString==="."){// .键
                if (!/^\d+\.?\d*$/.test($scope.NumberKeyboard.currentString+keyString)){
                    return;
                }
            }else if(keyString==="c"){// 关闭键盘
                $scope.NumberKeyboard.hideKeyBoard();
                return;
                // }else if(keyString === 0){//0键
                //     if (!/^(\d+\.?)?\d*$/.test($scope.NumberKeyboard.currentString+keyString)){
                //         return;
                //     }
                // }else if (keyString === 'b'){
                //     if (!$scope.isValid($scope.NumberKeyboard.currentString)){
                //         return;
                //     }
            }

            $scope.NumberKeyboard.currentString = $scope.NumberKeyboard.onInput(keyString);
        };

        $scope.NumberKeyboard.doFinishInput = null;
        $scope.NumberKeyboard.onInput = null;
        $scope.NumberKeyboard.doHideKeyboard = null;
        $scope.NumberKeyboard.finishInput = function(){
            $scope.NumberKeyboard.hide();
            if ($scope.isValid($scope.NumberKeyboard.doFinishInput)) {
                $scope.NumberKeyboard.doFinishInput();
            }
            $scope.NumberKeyboard.beforeString = $scope.NumberKeyboard.currentString ;
        };
        $scope.NumberKeyboard.url = 'templates/component/number_keyboard.html';
        $scope.NumberKeyboard.showKeyBoard = function(beforeNumber, onInput, doFinishInput, doHideKeyboard){
            $scope.NumberKeyboard.status = true;
            $scope.NumberKeyboard.beforeString = beforeNumber;
            $scope.NumberKeyboard.currentString = beforeNumber;
            $scope.NumberKeyboard.onInput = onInput;
            $scope.NumberKeyboard.doFinishInput = doFinishInput;
            $scope.NumberKeyboard.doHideKeyboard = doHideKeyboard;

            // $ionicPopover.fromTemplateUrl('templates/component/number_keyboard.html', {
            //     scope: $scope,
            //     animation: 'slide-in-up'
            // }).then(function (popover) {
            //     $scope.NumberKeyboard.popover = popover;
            //
            //     $scope.$on('popover.hidden', function () {
            //         $scope.NumberKeyboard.status = false;
            //         if ($scope.NumberKeyboard.popover){
            //             $timeout(function() {
            //                 popover.remove();
            //             }, 100);
            //         }
            //     });
            //     $scope.NumberKeyboard.popover.show();
            // });
        };
        $scope.NumberKeyboard.hide = function(){
            $scope.NumberKeyboard.status = false;
            // if ($scope.NumberKeyboard.popover){
            //     $scope.NumberKeyboard.popover.hide();
            // }
        };
        $scope.NumberKeyboard.hideKeyBoard = function(){
            if ($scope.isValid($scope.NumberKeyboard.doHideKeyboard)){
                $scope.NumberKeyboard.doHideKeyboard($scope.NumberKeyboard.beforeString);
            }
            $scope.NumberKeyboard.hide();
        };
    })

    .controller('UserAuthenController', function($scope, $rootScope, $http, $state, $stateParams, $ionicModal, $ionicPopup, $ionicLoading, $ionicHistory, $window, $timeout, config) {
        $scope.UserAuthen = $rootScope.UserAuthen;
        var defaultGet = '获取验证码';

        $scope.initUserAuthen = function(){
            if ($scope.isValid($stateParams.title)){
                $scope.Tips.show(1000, $stateParams.title, null);
            }
            if ($scope.isValid($scope.UserAuthen)){
                if ($scope.isValid($stateParams.url)){
                    $scope.UserAuthen.targetUrl = $stateParams.url;
                }

                $scope.UserAuthen.code = '';
                $scope.UserAuthen.requesting = false;
                $scope.UserAuthen.errorOn = '';
                $scope.UserAuthen.errorMessage = '';
                $scope.UserAuthen.time = -1;
                $scope.UserAuthen.get = defaultGet;
                $scope.UserAuthen.isGet = false;

                return $scope.UserAuthen;
            }
            $rootScope.UserAuthen = $scope.UserAuthen = {};
            $scope.UserAuthen.targetUrl = '';
            if ($scope.isValid($stateParams.url)){
                $scope.UserAuthen.targetUrl = $stateParams.url;
            }

            $scope.getToken(null);

            $scope.UserAuthen.login_type = '普通登录';

            $scope.UserAuthen.MiniLogin = {};
            $scope.UserAuthen.MiniLogin.isShow = function(){return $scope.isValid($scope.UserAuthen.MiniLogin.modal);};
            $scope.UserAuthen.MiniLogin.hide = function(){};
            $scope.UserAuthen.MiniLogin.show = function(title, callback){
                $scope.UserAuthen.MiniLogin.title = '快速进入'+title;
                $scope.UserAuthen.code = '';
                $scope.UserAuthen.requesting = false;
                $scope.UserAuthen.errorOn = '';
                $scope.UserAuthen.errorMessage = '';
                $scope.UserAuthen.time = -1;
                $scope.UserAuthen.get = defaultGet;
                $scope.UserAuthen.isGet = false;

                $ionicModal.fromTemplateUrl('templates/component/mini_login.html', {
                    scope: $scope,
                    animation: 'slide-in-up'
                }).then(function(modal) {
                    $scope.UserAuthen.MiniLogin.modal = modal;
                    $scope.UserAuthen.MiniLogin.modal.show();

                    $scope.UserAuthen.MiniLogin.hide = function(){
                        if ($scope.UserAuthen.NumberKeyboard){
                            $scope.UserAuthen.NumberKeyboard.hideKeyBoard();
                        }
                        if ($scope.isValid($scope.UserAuthen.MiniLogin.modal)){
                            $scope.Tips.hide();
                            $scope.UserAuthen.MiniLogin.modal.remove();
                            $scope.UserAuthen.MiniLogin.modal = null;
                            $scope.UserAuthen.MiniLogin.hide = function(){};
                        }
                        if ($scope.UserAuthen.isLogin()){
                            $scope.UserAuthen.MiniLogin.title = '正在进入'+title;
                            if ($scope.isValid(callback)){callback();}
                        }
                    };
                });
            };
            $scope.UserAuthen.hide = function(){
                $scope.Tips.hide();
                $ionicLoading.hide();
                if ($scope.UserAuthen.NumberKeyboard){
                    $scope.UserAuthen.NumberKeyboard.hideKeyBoard();
                }
                if ($scope.isValid($scope.UserAuthen.MiniLogin.modal)){
                    $scope.UserAuthen.MiniLogin.hide();
                }
            };

            $scope.UserAuthen.focus = {};
            $scope.UserAuthen.focusElement = function(valueKey, noNeedLoop){
                $scope.loop.removeLoop('number_keyboard');
                $scope.UserAuthen.focus = {};
                $timeout(function(){
                    $scope.UserAuthen.focus[valueKey] = true;
                }, 200);
                if (noNeedLoop){return;}
                $scope.loop.addLoop('number_keyboard', function(){
                    if ($scope.UserAuthen.focus[valueKey]){
                        $scope.UserAuthen.focus[valueKey] = false;
                    }else{
                        $scope.UserAuthen.focus[valueKey] = true;
                    }
                }, 600);
            };
            $scope.UserAuthen.blurElement = function(valueKey){
                if ($scope.isValid(valueKey)){
                    $scope.UserAuthen.focus[valueKey] = false;
                }else{
                    $scope.loop.removeLoop('number_keyboard');
                    $scope.UserAuthen.focus = {};
                }
            };

            $scope.UserAuthen.setUserInfo = function(key, value){
                if ($scope.isValid(key) && $scope.isValid(value)){
                    $scope.UserAuthen.base[key] = value;
                    $scope.UserAuthen.setBaseUserInfo(angular.toJson($scope.UserAuthen.base));
                }
            };
            $scope.UserAuthen.setBaseUserInfo = function(value){
                $window.localStorage.setItem("user.profile", value);
            };

            $scope.UserAuthen.getUserInfo = function(){
                if ($scope.isValid($window.localStorage.getItem('user.profile'))){
                    return angular.fromJson($window.localStorage.getItem('user.profile'));
                }else{
                    var base = {};
                    base.mobile = $window.localStorage.getItem('user.mobile');
                    base.full_name = $window.localStorage.getItem('user.full_name');
                    base.serial_id = $window.localStorage.getItem('user.serial_id');
                    base.login_time = $window.localStorage.getItem('user.login_time');

                    $scope.UserAuthen.setBaseUserInfo(angular.toJson(base));
                    return base;
                }
            };

            $scope.UserAuthen.base = $scope.UserAuthen.getUserInfo();

            $scope.UserAuthen.switchType = function(NumberKeyboard, args) {
                $scope.UserAuthen.login_type = args;
                if ($scope.isValid(NumberKeyboard)){
                    $scope.UserAuthen.NumberKeyboard = NumberKeyboard;
                    $scope.UserAuthen.NumberKeyboard.hideKeyBoard();
                }
            };

            $scope.UserAuthen.password = '';
            $scope.UserAuthen.mobile = $scope.isValid($scope.UserAuthen.base.mobile)?$scope.UserAuthen.base.mobile:'';

            $scope.UserAuthen.goTarget = function(targetUrl) {
                $scope.UserAuthen.password = '';
                $ionicLoading.hide();

                $scope.UserAuthen.targetUrl = $scope.isValid(targetUrl)?targetUrl:$scope.UserAuthen.targetUrl;
                if ($scope.isValid($scope.UserAuthen.targetUrl)){
                    $scope.goUrl($scope.UserAuthen.targetUrl);
                    $scope.UserAuthen.targetUrl = '';
                }else{
                    $scope.UserAuthen.doBack();
                }
            };

            $scope.UserAuthen.doBack = function() {
                $scope.UserAuthen.password = '';
                $ionicLoading.hide();

                if ($ionicHistory.backView()) {
                    $ionicHistory.goBack();
                }else{
                    $scope.goUrl('personal', {}, false, true);
                }
            };

            $scope.UserAuthen.isLogin = function(callback) {
                if ($scope.isValid($scope.UserAuthen.base.serial_id) && $scope.isValid($scope.UserAuthen.base.login_time) && $scope.UserAuthen.base.login_time + 7776000 > new Date().getTime() / 1000) {
                    return true;
                }
                if ($scope.isValid(callback)){
                    callback();
                }
                return false;
            };

            $scope.UserAuthen.doLogin = function(callback){
                if ($scope.UserAuthen.isLogin()){
                    if ($scope.isValid(callback)){callback();}
                }else{
                    $ionicLoading.show({
                        content: 'Loading',
                        animation: 'fade-in',
                        showBackdrop: true,
                        maxWidth: 200,
                        duration: 10000,
                        showDelay: 0
                    });

                    var params = {};
                    params[config.TOKEN_NAME] = $scope.getToken(true);
                    params.serial_id = $scope.UserAuthen.base.serial_id;
                    params.client = config.client;
                    params.app_product_key = config.app_product_key;

                    $http({
                        timeout: 10000,
                        method: 'jsonp',
                        url: config.data_domain + "/index.php/authen/check?callback=JSON_CALLBACK",
                        params: params
                    })
                    .success(function (response) {
                        $scope.getToken(response);
                        if (response.success) {

                            $scope.UserAuthen.base = response.data.profile;
                            $scope.UserAuthen.setUserInfo("mobile", $scope.UserAuthen.mobile);

                            // $scope.UserAuthen.setUserInfo("user.mobile", $scope.UserAuthen.mobile);
                            // $scope.UserAuthen.setUserInfo("user.full_name", response.data.full_name);
                            // $scope.UserAuthen.setUserInfo("user.serial_id", response.data.serial_id);
                            // $scope.UserAuthen.setUserInfo("user.login_time", response.data.login_time);
                            //
                            // $scope.UserAuthen.base.serial_id = response.data.serial_id;
                            // $scope.UserAuthen.base.login_time = response.data.login_time;
                            // $scope.UserAuthen.base.full_name = response.data.full_name;
                            // $scope.UserAuthen.base.mobile = $scope.UserAuthen.mobile;

                            $scope.UserAuthen.password = '';

                            // $scope.Tips.show(1000, '登录成功', function(){ callback(); });

                        // } else {
                        //     $scope.Tips.show(2000, response.message, null);
                        }else{

                            $scope.UserAuthen.setUserInfo("serial_id", '');
                            $scope.UserAuthen.setUserInfo("login_time", '');
                            // $window.localStorage.removeItem("user.serial_id");
                            // $window.localStorage.removeItem("user.login_time");
                            // $window.localStorage.removeItem("user.full_name");
                            // $window.localStorage.removeItem("user.mobile");

                            // $scope.UserAuthen.base.serial_id = '';
                            // $scope.UserAuthen.base.login_time = '';
                            // $scope.UserAuthen.base.full_name = '';
                            // $scope.UserAuthen.base.mobile = '';
                            $scope.UserAuthen.code = '';
                            $scope.UserAuthen.password = '';

                            $scope.UserAuthen.get = defaultGet;
                            $scope.UserAuthen.isGet = false;
                            $scope.UserAuthen.requesting = false;
                            $scope.UserAuthen.time = -1;
                        }
                    })
                    .error(function (response, status) {
                        // $scope.Tips.show(2000, '网络不可用，请检查您的网络设置', null);
                        // if ($scope.isValid(callback)){callback(null);}
                    })
                    .finally(function() {
                        $ionicLoading.hide();
                    })
                    ;
                }
            };

            $scope.UserAuthen.login = function(callback){
                if (!$scope.UserAuthen.validateMobile()){
                    $scope.Tips.show(1000, '请输入正确的手机号', null);
                    return false;
                }

                if (!$scope.isValid($scope.UserAuthen.password) || $scope.UserAuthen.password.length<6){
                    $scope.Tips.show(1000, '密码格式输入有误', null);
                    return false;
                }

                if ($scope.UserAuthen.requesting){return false;}
                $scope.UserAuthen.requesting = true;

                $ionicLoading.show({
                    content: 'Loading',
                    animation: 'fade-in',
                    showBackdrop: true,
                    maxWidth: 200,
                    duration: 10000,
                    showDelay: 0
                });

                var params = {};
                params[config.TOKEN_NAME] = $scope.getToken(true);
                params.mobile = $scope.UserAuthen.mobile;
                params.password = md5("$scope.UserAuthen.password-"+$scope.UserAuthen.password);
                params.client = config.client;
                params.app_product_key = config.app_product_key;

                $scope.UserAuthen.password = '';
                $http({
                    timeout: 10000,
                    method: 'jsonp',
                    url: config.data_domain + "/index.php/authen/login?callback=JSON_CALLBACK",
                    params: params
                })
                .success(function (response) {
                    $scope.UserAuthen.password = '';
                    $scope.getToken(response);
                    if (response.success) {
                        $scope.UserAuthen.base = response.data.profile;
                        $scope.UserAuthen.setUserInfo("mobile", $scope.UserAuthen.mobile);

                        $scope.UserAuthen.password = '';

                        $scope.Tips.show(1000, '登录成功', callback);
                    } else {
                        $scope.Tips.show(2000, response.message, null);
                    }
                })
                .error(function (response, status) {
                    $scope.Tips.show(2000, '网络不可用，请检查您的网络设置', function () {
                        // $scope.UserAuthen.login(callback);
                    });
                    // if ($scope.isValid(callback)){callback(null);}
                })
                .finally(function() {
                    $ionicLoading.hide();
                    $scope.UserAuthen.requesting = false;
                })
                ;
                return true;
            };

            $scope.UserAuthen.logout = function(callback, isShow){
                $ionicLoading.hide();
                if (!$scope.UserAuthen.isLogin($scope.UserAuthen.doBack)) {
                    return;
                }

                $window.localStorage.removeItem("user.profile");

                $window.localStorage.removeItem("user.serial_id");
                $window.localStorage.removeItem("user.login_time");
                $window.localStorage.removeItem("user.full_name");
                $window.localStorage.removeItem("user.mobile");

                $scope.UserAuthen.base = {};

                $scope.UserAuthen.code = '';
                $scope.UserAuthen.password = '';

                $scope.UserAuthen.get = defaultGet;
                $scope.UserAuthen.isGet = false;
                $scope.UserAuthen.requesting = false;
                $scope.UserAuthen.time = -1;

                $ionicHistory.clearHistory();
                if (isShow){
                    $scope.Tips.show(1000, '注销成功', callback);
                }

                $scope.doBack(true);
                return;
            };

            $scope.UserAuthen.reset = function(callback){
                if (!$scope.isValid($scope.UserAuthen.password) || $scope.UserAuthen.password.length<6){
                    $scope.Tips.show(1000, '密码为6位以上字符', null);
                    return false;
                }

                if (!$scope.UserAuthen.isLogin($scope.UserAuthen.doBack)) {
                    return false;
                }
                if ($scope.UserAuthen.requesting){return false;}
                $scope.UserAuthen.requesting = true;

                $ionicLoading.show({
                    content: 'Loading',
                    animation: 'fade-in',
                    showBackdrop: true,
                    maxWidth: 200,
                    duration: 10000,
                    showDelay: 0
                });

                var params = {};
                params[config.TOKEN_NAME] = $scope.getToken(true);
                params.serial_id = $scope.UserAuthen.base.serial_id;
                params.password = md5("$scope.UserAuthen.password-"+$scope.UserAuthen.password);
                params.client = config.client;
                params.app_product_key = config.app_product_key;

                $scope.UserAuthen.password = '';
                $http({
                    timeout: 10000,
                    method: 'jsonp',
                    url: config.data_domain + "/index.php/authen/reset?callback=JSON_CALLBACK",
                    params: params
                })
                .success(function (response) {
                    $ionicLoading.hide();
                    $scope.getToken(response);
                    if (response.success) {

                        $scope.UserAuthen.base = response.data.profile;
                        $scope.UserAuthen.setUserInfo("mobile", $scope.UserAuthen.mobile);

                        // $scope.UserAuthen.setUserInfo("user.full_name", response.data.full_name);
                        // $scope.UserAuthen.setUserInfo("user.serial_id", response.data.serial_id);
                        // $scope.UserAuthen.setUserInfo("user.login_time", response.data.login_time);
                        //
                        // $scope.UserAuthen.base.serial_id = response.data.serial_id;
                        // $scope.UserAuthen.base.login_time = response.data.login_time;
                        // $scope.UserAuthen.base.full_name = response.data.full_name;

                        $scope.Tips.show(1000, '设置成功', callback);
                    } else {
                        $scope.Tips.show(2000, response.message, null);
                    }
                })
                .error(function (response, status) {
                    $scope.Tips.show(2000, '网络不可用，请检查您的网络设置', function () {
                        // $scope.UserAuthen.reset(callback);
                    });
                    if ($scope.isValid(callback)){callback(null);}
                })
                .finally(function() {
                    $scope.UserAuthen.requesting = false;
                    $ionicLoading.hide();
                })
                ;
                return true;
            };

            $scope.UserAuthen.get = defaultGet;
            $scope.UserAuthen.isGet = false;
            $scope.UserAuthen.time = -1;
            $scope.UserAuthen.code = '';
            $scope.UserAuthen.requesting = false;
            $scope.UserAuthen.mobile = $scope.UserAuthen.base.mobile;
            $scope.UserAuthen.errorOn = '';
            $scope.UserAuthen.errorMessage = '';
            // $scope.UserAuthen.mobile = '';
            // $scope.UserAuthen.mobile = '13222222222';

            $scope.UserAuthen.validateMobile = function(){
                $scope.UserAuthen.mobile = $scope.isValid($scope.UserAuthen.mobile)?$scope.UserAuthen.mobile.replace(/\s+/igm, ""):'';
                if (!/^1[34578]\d{9}$/igm.test($scope.UserAuthen.mobile)){
                    return false;
                }
                return true;
            };

            $scope.loop.removeLoop('number_keyboard');
            $scope.UserAuthen.showUserAuthenKeyBoard = function(NumberKeyboard, valueKey, callback, autoVerify){
                $scope.UserAuthen.NumberKeyboard = NumberKeyboard;
                $scope.UserAuthen.code = '';

                if (valueKey==='code'){
                    if (!$scope.isValid($scope.UserAuthen.mobile)){
                        $scope.UserAuthen.focusElement('mobile');
                        if ($scope.UserAuthen.MiniLogin.isShow()) {
                            $scope.UserAuthen.errorOn = $scope.UserAuthen.mobile?'mobile_error':'mobile';
                        // } else {
                        //     $scope.Tips.show(1000, '请输入手机号', null);
                        }
                        $scope.UserAuthen.mobile = '';
                        return false;
                    }
                    // if (!$scope.UserAuthen.validateMobile()) {
                    //     $scope.UserAuthen.focusElement('mobile');
                    //     if ($scope.UserAuthen.MiniLogin.isShow()) {
                    //         $scope.UserAuthen.errorOn = $scope.UserAuthen.mobile?'mobile_error':'mobile';
                    //     } else {
                    //         $scope.Tips.show(1000, '请输入正确的手机号', null);
                    //     }
                    //     $scope.UserAuthen.mobile = '';
                    //     return false;
                    // }
                    // if (!$scope.UserAuthen.isGet) {
                    //     $scope.UserAuthen.focusElement('mobile');
                    //     if ($scope.UserAuthen.MiniLogin.isShow()){
                    //         $scope.UserAuthen.errorOn = 'get';
                    //     }else {
                    //         $scope.Tips.show(1000, '请先获取验证码', function (){$scope.UserAuthen.code = ''});
                    //     }
                    //     return false;
                    // }
                }
                $scope.UserAuthen.focusElement(valueKey);

                $scope.UserAuthen.NumberKeyboard.showKeyBoard($scope.UserAuthen[valueKey],
                    function (keyString){
                        if ($scope.UserAuthen.requesting){return;}
                        if (!$scope.UserAuthen[valueKey]){$scope.UserAuthen[valueKey]='';}
                        if (keyString==="."){
                            return;
                        }
                        if (keyString==="b"){
                            $scope.UserAuthen[valueKey] += '';
                            if ($scope.isValid($scope.UserAuthen[valueKey])){
                                $scope.UserAuthen[valueKey] = $scope.UserAuthen[valueKey].substr(0, $scope.UserAuthen[valueKey].length-1);
                            }
                            return;
                        }

                        $scope.UserAuthen[valueKey] += keyString;
                        if (valueKey==='code'){
                            $scope.UserAuthen.errorOn = $scope.UserAuthen.code?'code_error':'code';
                            if ($scope.UserAuthen[valueKey].length===4 && autoVerify){
                                $scope.UserAuthen.UserAuthenCode(callback, true);
                            }else{
                                $scope.UserAuthen[valueKey] = $scope.UserAuthen[valueKey].substr(0, 4);
                            }
                        }

                        if (valueKey==='mobile'){
                            if ($scope.UserAuthen[valueKey].length>11) {
                                $scope.UserAuthen[valueKey] = $scope.UserAuthen[valueKey].substr(0, 11);
                            }
                        }
                        return $scope.UserAuthen[valueKey];
                    },
                    function(){
                        if (!$scope.UserAuthen.validateMobile()){
                            $scope.UserAuthen.focus.mobile = true;
                            if ($scope.UserAuthen.MiniLogin.isShow()){
                                $scope.UserAuthen.errorOn = $scope.UserAuthen.mobile?'mobile_error':'mobile';
                            }else {
                                $scope.Tips.show(1000, '请输入正确的手机号', null);
                            }
                            $scope.UserAuthen.mobile = '';
                            return false;
                        }

                        if ($scope.UserAuthen.code.length===4 && autoVerify){
                            $scope.UserAuthen.UserAuthenCode(callback, true);
                        }
                        if ($scope.UserAuthen.validateMobile()){
                            $scope.UserAuthen.NumberKeyboard.hide();
                        }
                        return $scope.UserAuthen[valueKey];
                    },
                    function(beforeNumber){
                        $scope.UserAuthen.NumberKeyboard.hide();
                    });
                return true;
            };

            $scope.UserAuthen.clock = function(){
                $scope.UserAuthen.time-=1;
                if ($scope.UserAuthen.time<1){
                    $scope.UserAuthen.get = defaultGet;
                    $scope.UserAuthen.time = -1;
                    return;
                }
                $scope.UserAuthen.get = $scope.UserAuthen.time + '秒';
                $timeout(function(){
                    $scope.UserAuthen.clock();
                }, 1000);
            };

            $scope.UserAuthen.getUserAuthenCode = function(callback){
                if (!$scope.UserAuthen.validateMobile()){
                    $scope.UserAuthen.focusElement('mobile');
                    if ($scope.UserAuthen.MiniLogin.isShow()) {
                        $scope.UserAuthen.errorOn = $scope.UserAuthen.mobile?'mobile_error':'mobile';
                        $scope.UserAuthen.mobile = '';
                    } else {
                        $scope.Tips.show(1000, '请输入正确的手机号', null);
                    }
                    return false;
                }

                if ($scope.UserAuthen.requesting){return false;}
                $scope.UserAuthen.requesting = true;

                $scope.UserAuthen.get = '发送中..';
                $scope.UserAuthen.time = 60;
                $scope.UserAuthen.code = '';

                $scope.UserAuthen.errorOn = '';
                $scope.UserAuthen.errorMessage = '';

                var params = {};
                params[config.TOKEN_NAME] = $scope.getToken(true);
                params.mobile = $scope.UserAuthen.mobile;
                params.client = config.client;
                params.app_product_key = config.app_product_key;

                $http({
                    timeout: 10000,
                    method: 'jsonp',
                    url: config.data_domain + "/index.php/authen/get?callback=JSON_CALLBACK",
                    params: params
                })
                .success(function (response) {
                    $scope.getToken(response);
                    $scope.UserAuthen.get = defaultGet;
                    if (response.success){
                        $scope.UserAuthen.isGet = true;
                        $scope.UserAuthen.clock();
                        if ($scope.isValid(callback)){callback(response);}
                    }else{
                        $scope.UserAuthen.time = -1;
                        if (response.code===3){
                            $scope.UserAuthen.errorMessage = response.message;
                        }
                        if ($scope.UserAuthen.MiniLogin.isShow()){
                            $scope.UserAuthen.errorOn = 'get';
                            $scope.UserAuthen.code = '';
                        }else{
                            $scope.Tips.show(2000, response.message, function (){$scope.UserAuthen.code = '';});
                        }
                    }
                })
                .error(function () {
                    $scope.UserAuthen.get = defaultGet;

                    $scope.UserAuthen.isGet = false;
                    $scope.UserAuthen.time = -1;
                    $scope.UserAuthen.errorOn = 'get';
                    $scope.UserAuthen.code = '';

                    $scope.Tips.show(2000, '网络不可用，请检查您的网络设置', function () {
                        // $scope.UserAuthen.getUserAuthenCode(callback);
                    });
                })
                .finally(function() {
                    $scope.UserAuthen.requesting = false;
                })
                ;
                return true;
            };

            $scope.UserAuthen.UserAuthenCode = function(callback, isTips){
                $scope.UserAuthen.errorMessage = '';
                if (!$scope.isValid($scope.UserAuthen.mobile)){
                    $scope.UserAuthen.focusElement('mobile');
                    if ($scope.UserAuthen.MiniLogin.isShow()) {
                        $scope.UserAuthen.errorOn = $scope.UserAuthen.mobile?'mobile_error':'mobile';
                        } else {
                            $scope.Tips.show(1000, '请输入手机号', function(){$scope.UserAuthen.code = '';});
                    }
                    $scope.UserAuthen.mobile = '';
                    $scope.UserAuthen.showUserAuthenKeyBoard($scope.UserAuthen.NumberKeyboard, 'mobile', $scope.UserAuthen.goTarget);
                    return false;
                }
                if (!$scope.UserAuthen.validateMobile()){
                    $scope.UserAuthen.focusElement('mobile');
                    if ($scope.UserAuthen.MiniLogin.isShow()) {
                        $scope.UserAuthen.errorOn = $scope.UserAuthen.mobile?'mobile_error':'mobile';
                        $scope.UserAuthen.mobile = '';
                    } else {
                        $scope.Tips.show(1000, '请输入正确的手机号', function(){$scope.UserAuthen.code = '';});
                    }
                    $scope.UserAuthen.showUserAuthenKeyBoard($scope.UserAuthen.NumberKeyboard, 'mobile', $scope.UserAuthen.goTarget);
                    return false;
                }
                if (!$scope.UserAuthen.isGet) {
                    $scope.UserAuthen.focusElement('get');
                    if ($scope.UserAuthen.MiniLogin.isShow()){
                        $scope.UserAuthen.errorOn = 'get';
                    }else {
                        $scope.Tips.show(1000, '请先获取验证码', function(){$scope.UserAuthen.code = '';});
                    }
                    $scope.UserAuthen.code = '';
                    // $scope.UserAuthen.showUserAuthenKeyBoard($scope.UserAuthen.NumberKeyboard, 'mobile', $scope.UserAuthen.goTarget);
                    return false;
                }

                $scope.UserAuthen.code = $scope.UserAuthen.code.replace(/\D+/,'');

                if (!/^\d{4}$/.test($scope.UserAuthen.code)) {
                    $scope.UserAuthen.focusElement('code');
                    if ($scope.UserAuthen.MiniLogin.isShow()){
                        $scope.UserAuthen.errorOn = $scope.UserAuthen.code?'code_error':'code';
                    }else {
                        $scope.Tips.show(1000, '验证码不正确', function (){$scope.UserAuthen.code = '';});
                    }

                    $scope.UserAuthen.code = '';
                    $scope.UserAuthen.showUserAuthenKeyBoard($scope.UserAuthen.NumberKeyboard, 'mobile', $scope.UserAuthen.goTarget);
                    return false;
                }

                if ($scope.UserAuthen.requesting){return false;}
                $scope.UserAuthen.requesting = true;

                if ($scope.UserAuthen.MiniLogin.isShow()){
                    $scope.UserAuthen.errorOn = '';
                }else{
                    $scope.Tips.show($scope.isValid(isTips)?1000:0, '验证中', null);
                }

                var params = {};
                params[config.TOKEN_NAME] = $scope.getToken(true);
                params.code = $scope.UserAuthen.code;
                params.mobile = $scope.UserAuthen.mobile;
                params.client = config.client;
                params.app_product_key = config.app_product_key;

                $http({
                    timeout: 10000,
                    method: 'jsonp',
                    url: config.data_domain + "/index.php/authen/verify?callback=JSON_CALLBACK",
                    params: params
                })
                .success(function (response) {
                    $scope.getToken(response);
                    if (response.success){
                        if($scope.UserAuthen.NumberKeyboard){
                            $scope.UserAuthen.NumberKeyboard.hide();
                        }

                        $scope.UserAuthen.base = response.data.profile;
                        $scope.UserAuthen.setUserInfo("mobile", $scope.UserAuthen.mobile);

                        // $scope.UserAuthen.setUserInfo("user.mobile", $scope.UserAuthen.mobile);
                        // $scope.UserAuthen.setUserInfo("user.full_name", response.data.full_name);
                        // $scope.UserAuthen.setUserInfo("user.serial_id", response.data.serial_id);
                        // $scope.UserAuthen.setUserInfo("user.login_time", response.data.login_time);
                        //
                        // $scope.UserAuthen.base.serial_id = response.data.serial_id;
                        // $scope.UserAuthen.base.login_time = response.data.login_time;
                        // $scope.UserAuthen.base.full_name = response.data.full_name;
                        // $scope.UserAuthen.base.mobile = $scope.UserAuthen.mobile;

                        $scope.UserAuthen.isGet = false;
                        if ($scope.UserAuthen.MiniLogin.isShow()){
                            $scope.UserAuthen.MiniLogin.hide();
                        }else{
                            $scope.Tips.show($scope.isValid(isTips)?1000:0, '验证成功', callback);
                        }
                        $scope.UserAuthen.code = '';
                    }else{
                        if (response.code===3){
                            $scope.UserAuthen.errorMessage = response.message;
                        }
                        if ($scope.UserAuthen.MiniLogin.isShow()){
                            $scope.UserAuthen.errorOn = $scope.UserAuthen.code?'code_error':'code';
                            $scope.UserAuthen.code = '';
                        }else{
                            $scope.Tips.show(1000, response.message, function (){$scope.UserAuthen.code = '';});
                        }
                    }
                })
                .error(function () {
                    $scope.Tips.show(2000, '网络不可用，请检查您的网络设置', function () {
                        // $scope.UserAuthen.UserAuthenCode(callback);
                    });
                })
                .finally(function() {
                    $scope.UserAuthen.requesting = false;
                })
                ;
                return;
            };

            return $scope.UserAuthen;
        };

    })

    .controller('CityController', function($scope, $ionicModal, $ionicBackdrop, $ionicScrollDelegate, $timeout) {
        $scope.City = {};
        $scope.City.citys = {
            "A":["阿克苏地区","阿勒泰地区","阿拉尔市","阿里地区","鞍山市","阿拉善盟","安庆市","安顺市","安康市","安阳市","阿坝藏族羌族自治州","澳门"],
            "B":["北京市","白银市","滨州市","白城市","白山市","巴音郭楞蒙古自治州","博尔塔拉蒙古自治州","百色市","北海市","本溪市","保亭黎族苗族自治县","白沙黎族自治县","巴彦淖尔市","包头市","蚌埠市","毕节地区","保定市","宝鸡市","保山市","巴中市"],
            "C":["重庆市","成都市","潮州市","长春市","长治市","昌吉回族自治州","昌都地区","崇左市","常州市","朝阳市","昌江黎族自治县","澄迈县","赤峰市","滁州市","巢湖市","池州市","沧州市","承德市","长沙市","常德市","郴州市","楚雄彝族自治州"],
            "D":["大兴安岭地区","大庆市","定西市","东莞市","东沙群岛","东营市","德州市","大同市","大连市","丹东市","定安县","东方市","大理白族自治州","迪庆藏族自治州","德宏傣族景颇族自治州","德阳市","达州市","儋州市"],
            "E":["鄂州市","恩施土家族苗族自治州","鄂尔多斯市"],"F":["佛山市","福州市","防城港市","阜新市","抚顺市","阜阳市","抚州市"],
            "G":["广州市","甘南藏族自治州","果洛藏族自治州","桂林市","贵港市","固原市","贵阳市","赣州市","甘孜藏族自治州","广安市","广元市"],
            "H":["杭州市","黑河市","鹤岗市","哈尔滨市","河源市","惠州市","菏泽市","海西蒙古族藏族自治州","海北藏族自治州","海南藏族自治州","海东地区","黄南藏族自治州","和田地区","哈密地区","黄冈市","黄石市","河池市","贺州市","淮安市","葫芦岛市","海口市","呼伦贝尔市","呼和浩特市","合肥市","淮南市","黄山市","淮北市","邯郸市","衡水市","衡阳市","怀化市","汉中市","红河哈尼族彝族自治州","湖州市","鹤壁市"],
            "J":["佳木斯市","鸡西市","嘉峪关市","金昌市","酒泉市","揭阳市","江门市","济宁市","济南市","吉林市","晋中市","晋城市","荆州市","荆门市","锦州市","金华市","嘉兴市","焦作市","济源市","景德镇市","吉安市","九江市"],
            "K":["喀什地区","克孜勒苏柯尔克孜自治州","克拉玛依市","昆明市","开封市"],
            "L":["兰州市","临夏回族自治州","陇南市","莱芜市","临沂市","聊城市","辽源市","吕梁市","临汾市","林芝地区","拉萨市","龙岩市","来宾市","柳州市","连云港市","辽阳市","陵水黎族自治县","乐东黎族自治县","临高县","六安市","六盘水市","廊坊市","娄底市","临沧市","丽江市","丽水市","洛阳市","乐山市","凉山彝族自治州","漯河市","泸州市"],
            "M":["牡丹江市","茂名市","梅州市","马鞍山市","眉山市","绵阳市"],
            "N":["南京市","那曲地区","南平市","宁德市","南宁市","南通市","南沙群岛","怒江傈僳族自治州","宁波市","南阳市","南昌市","内江市","南充市"],
            "P":["平凉市","莆田市","盘锦市","普洱市","平顶山市","萍乡市","攀枝花市","濮阳市"],
            "Q":["齐齐哈尔市","七台河市","庆阳市","清远市","青岛市","潜江市","泉州市","钦州市","琼中黎族苗族自治县","琼海市","黔南布依族苗族自治州","黔东南苗族侗族自治州","黔西南布依族苗族自治州","秦皇岛市","曲靖市","衢州市"],
            "R":["日照市","日喀则地区"],
            "S":["上海市","深圳市","苏州市","绥化市","双鸭山市","韶关市","汕头市","汕尾市","松原市","四平市","朔州市","石河子市","山南地区","十堰市","随州市","神农架林区","三明市","宿迁市","沈阳市","石嘴山市","三亚市","宿州市","石家庄市","邵阳市","商洛市","绍兴市","商丘市","三门峡市","上饶市","遂宁市"],
            "T":["天津市","天水市","泰安市","通化市","太原市","吐鲁番地区","塔城地区","图木舒克市","天门市","泰州市","铁岭市","屯昌县","通辽市","铜陵市","铜仁地区","唐山市","铜川市","台州市","台湾"],
            "W":["武汉市","武威市","威海市","潍坊市","乌鲁木齐市","五家渠市","梧州市","无锡市","吴忠市","万宁市","五指山市","文昌市","乌海市","乌兰察布市","芜湖市","渭南市","文山壮族苗族自治州","温州市"],
            "X":["西安市","忻州市","西宁市","襄阳市","孝感市","咸宁市","仙桃市","厦门市","徐州市","西沙群岛","兴安盟","锡林郭勒盟","宣城市","邢台市","湘西土家族苗族自治州","湘潭市","咸阳市","西双版纳傣族自治州","新乡市","许昌市","信阳市","新余市","香港"],
            "Y":["伊春市","阳江市","云浮市","烟台市","延边朝鲜族自治州","运城市","阳泉市","玉树藏族自治州","伊犁哈萨克自治州","宜昌市","玉林市","盐城市","扬州市","营口市","银川市","岳阳市","益阳市","永州市","榆林市","延安市","玉溪市","宜春市","鹰潭市","雅安市","宜宾市"],
            "Z":["张掖市","珠海市","中山市","湛江市","肇庆市","枣庄市","淄博市","漳州市","镇江市","中卫市","中沙群岛","遵义市","张家口市","株洲市","张家界市","昭通市","舟山市","郑州市","驻马店市","周口市","自贡市","资阳市"]};

        $scope.City.show = function(callback){
            if (!$scope.isValid($scope.City.model)){
                $ionicModal.fromTemplateUrl('templates/component/city_selection.html', {
                    scope: $scope
                }).then(function(modal) {
                    $scope.City.model = modal;
                    $scope.City.model.show();
                });
                $scope.City.chooseCity = function(city){
                    if ($scope.isValid(callback)){
                        callback(city);
                    }
                    $scope.City.model.hide();
                };
            }else{
                $scope.City.model.show();
            }

            $scope.City.scrollTo = function(code, head, level1, level2){
                var index = 0;
                var lastCount = 0;
                for(var item in $scope.City.citys){
                    if (item===code){
                        break;
                    }
                    lastCount += $scope.City.citys[item].length;
                    index++;
                }
                var height = head + level1*index + level2*lastCount;

                $ionicScrollDelegate.$getByHandle('cityScroll').scrollTo(0, height, true);
            };
        };
    })

    .controller('ConfirmController', function($scope, $ionicModal, $ionicBackdrop, $timeout) {
        $scope.Confirm = {};
        $scope.Confirm.title = '标题';
        $scope.Confirm.content = '内容';
        $scope.Confirm.okText = '确认';
        $scope.Confirm.cancelText = '取消';
        $scope.Confirm.globalCallback = null;
        $scope.Confirm.okCallback = null;
        $scope.Confirm.cancelCallback = null;
        $scope.Confirm.global = function(){
            if ($scope.Confirm.globalCallback){
                $scope.Confirm.globalCallback();
            }
            $scope.Confirm.hide();
        };

        $scope.Confirm.ok = function(){
            if ($scope.Confirm.okCallback){
                $scope.Confirm.okCallback();
            }
            $scope.Confirm.hide();
        };
        $scope.Confirm.cancel = function(){
            if ($scope.Confirm.cancelCallback){
                $scope.Confirm.cancelCallback();
            }
            $scope.Confirm.hide();
        };
        $scope.Confirm.hide = function(){};
        $scope.Confirm.status = false;
        $scope.Confirm.show = function(title, content, okCallback, cancelCallback){
            $scope.Confirm.title = title;
            $scope.Confirm.content = content;
            $scope.Confirm.okCallback = okCallback;
            $scope.Confirm.cancelCallback = cancelCallback;
            if ($scope.Confirm.title && $scope.Confirm.content){
                $ionicBackdrop.retain();

                $ionicModal.fromTemplateUrl('templates/component/confirm.html', {
                    scope: $scope,
                    animation: 'fade-out',
                    backdropClickToClose: false
                }).then(function(modal) {
                    $scope.Confirm.modal = modal;
                    $scope.Confirm.modal.show();
                    $scope.Confirm.status = true;

                    $scope.Confirm.hide = function(){
                        if ($scope.Confirm.modal){
                            $scope.Confirm.modal.remove();
                        }
                    };
                    $scope.$on('modal.hidden', function() {
                        $scope.Confirm.modal = null;
                        $scope.Confirm.status = false;
                        $ionicBackdrop.release();
                    });
                });
            }
        };
    })

    .controller('SelectionController', function($scope, $ionicModal, $ionicActionSheet, $ionicBackdrop, $timeout) {
        $scope.Selection = {};
        $scope.Selection.list = [];
        $scope.Selection.selectionCallback = '';
        $scope.Selection.select = function(index){
            if ($scope.Selection.selectionCallback(index)){
                $scope.Selection.hide();
            }
        };
        $scope.Selection.hide = function(){};
        $scope.Selection.show = function(list, selectionCallback){
            $scope.Selection.list = list;
            $scope.Selection.selectionCallback = selectionCallback;
            if ($scope.Selection.list.length>5){
                $ionicBackdrop.retain();

                $ionicModal.fromTemplateUrl('templates/component/selection.html', {
                    scope: $scope,
                    animation: 'slide-in-up',
                    backdropClickToClose: true
                }).then(function(modal) {
                    $scope.Selection.modal = modal;
                    $scope.Selection.modal.show();

                    $scope.Selection.hide = function(){
                        if ($scope.Selection.modal){
                            $scope.Selection.modal.remove();
                        }
                    };
                    $scope.$on('modal.hidden', function() {
                        $scope.Selection.modal = null;
                        $ionicBackdrop.release();
                    });
                });
            }else {
                var textList = [];
                for(var i=0; i<$scope.Selection.list.length; i++){
                    textList.push({text: $scope.Selection.list[i]});
                }

                var sheet = $ionicActionSheet.show({
                    buttons: textList,
                    cancelText: "取消",
                    cssClass: 'up_buttons',
                    cancel: function () {
                        $scope.Selection.select(-1);
                    },
                    buttonClicked: function (index) {
                        $scope.Selection.select(index);
                        return true;
                    }
                });

                $scope.Selection.hide = function(){ };
                $scope.Selection.modal = sheet;
            }
        };
    })

    .controller('FooterNavigateController', function($scope, $state, $ionicScrollDelegate, $ionicHistory, $timeout) {
        // $scope.icon_nav_index = "_off";
        // $scope.icon_nav_list = "_off";
        // $scope.icon_nav_personal = "_off";

        $scope.icon_nav = "";

        $scope.selectionNav = function(index, isReload){
            $scope.appUpdate();

            $ionicHistory.clearHistory();

            $scope.icon_nav = index;

            // $scope[index] = "_on";

            $scope.goUrl(index, {reload: isReload}, false, true);
            $timeout(function(){
                $scope.icon_nav = "";
                // $scope[index] = "_off";
            }, 1000);
            $ionicScrollDelegate.scrollTop();
        };
    })

    .controller('IndexController', function($scope, $http, $ionicSlideBoxDelegate, $ionicHistory, $ionicScrollDelegate, $timeout, $window, config) {
        if (!$scope.isValid($window.localStorage.getItem(config.WELLCOME_TOKEN_NAME))){
            $scope.goUrl('wellcome', {}, false, true);
            return;
        }
        $window.localStorage.setItem(config.WELLCOME_TOKEN_NAME, new Date().getTime());

        $ionicHistory.clearHistory();

        $scope.appUpdate();

        $scope.config = config;

        $scope.loop.resumeAllLoop();

        $scope.index = {};

        $scope.banner_list = [];//{'link':'http://wap.vcash.cn', 'logo_mid':'img/banner@2x.png'}];

        $scope.slideDisplay = false;

        $scope.offset = 0;
        $scope.total = 0;
        $scope.canRefresh = true;
        $scope.product_list = [];

        $scope.UpDownSlide = {};
        $scope.UpDownSlide.list_0 = [];
        $scope.UpDownSlide.list_1 = [];
        $scope.UpDownSlide.index = 0;
        $scope.UpDownSlide.slide_index = 0;
        $scope.UpDownSlide.show = function(arrays){
            var list_0 = [];
            list_0.push(arrays[$scope.UpDownSlide.index++]);
            $scope.UpDownSlide.index = $scope.UpDownSlide.index===arrays.length?0:$scope.UpDownSlide.index;
            list_0.push(arrays[$scope.UpDownSlide.index]);
            $scope.UpDownSlide.index = $scope.UpDownSlide.index===arrays.length?0:$scope.UpDownSlide.index;
            $scope.UpDownSlide['list_'+$scope.UpDownSlide.slide_index] = list_0;

            $scope.loop.addLoop('index_slide_secc', function(){$scope.UpDownSlide.showLoop(arrays);}, 2000);
        };

        $scope.UpDownSlide.showLoop = function(arrays) {
            $ionicScrollDelegate.$getByHandle('upDownSlideBoxHandler_' + $scope.UpDownSlide.slide_index).scrollBottom(true);

            var off = $scope.UpDownSlide.slide_index === 0 ? 1 : 0;

            var list_1 = [];
            list_1.push(arrays[$scope.UpDownSlide.index++]);
            $scope.UpDownSlide.index = $scope.UpDownSlide.index === arrays.length ? 0 : $scope.UpDownSlide.index;
            list_1.push(arrays[$scope.UpDownSlide.index]);
            $scope.UpDownSlide.index = $scope.UpDownSlide.index === arrays.length ? 0 : $scope.UpDownSlide.index;
            $scope.UpDownSlide['list_' + off] = list_1;

            // $ionicScrollDelegate.$getByHandle('upDownSlideBoxHandler_' + off).resize();
            $ionicScrollDelegate.$getByHandle('upDownSlideBoxHandler_' + off).scrollTop(false);
            $timeout(function () {
                $scope.UpDownSlide.slide_index = off;
                // $scope.UpDownSlide.showLoop(arrays);
            }, 2000);
        };

        var H5jumper = null;
        $scope.initAndroidVersion = function(jumper, Confirm){
            H5jumper = H5jumper==null?jumper:H5jumper;

            var os = config.client.device.OS.toUpperCase();
            if (!$scope.isValid(os)){
                $timeout(function () {
                    $scope.initAndroidVersion(H5jumper, Confirm);
                }, 1000);
            }
            if (os.startsWith('ANDROID')){
                var version = os.replace(/[^0-9]+/igm, '')+'000';
                version = parseFloat(version.substring(0, 3));
                if (version<440){
                    Confirm.globalCallback = function(){
                        var winParams = {};
                        winParams.brand_name = '惠借贷款';
                        winParams.product_type = '';
                        winParams.product_name = '惠借贷款';
                        winParams.interface_type = 'H5_OUT';
                        winParams.interface_content = config.assets_domain+ '/apk/android-huijie.apk';//'https://www.huijiekuan.com/download.html';
                        H5jumper.openWindow(winParams);
                    };
                    Confirm.show('更新提示', '经检测您的安卓系统版本过旧，可能导致此应用使用不顺畅，推荐您立即下载安装“惠借贷款（至尊版）”');
                }
            }
        };

        $scope.isEnd = false;
        $scope.doRefresh = function(isForce) {
            if (isForce){
                $scope.isEnd = false;
                $scope.offset = 0;
            }

            var params = {};
            params.offset = $scope.offset;
            // params['client'] = config.client;
            params.app_product_key = config.app_product_key;

            $http({
                timeout: 10000,
                cache: !isForce,
                method: 'jsonp',
                url: config.data_domain + "/index.php/?callback=JSON_CALLBACK",
                params: params
            })
            .success(function (response) {
                if (!response.success){
                    $scope.isEnd = false;
                    $scope.Tips.show(2000, response.message, null);
                    return;
                }

                if (!angular.equals($scope.banner_list, response.data.banner_750X270)){
                    var lastTime = 0;
                    var loadBanners = function(image_list){
                        if (lastTime+3000>new Date().getTime()){
                            return;
                        }
                        lastTime = new Date().getTime();
                        for(var obj in image_list) {
                            image_list[obj].logo_mid = image_list[obj].image.src;
                            image_list[obj].image = null;
                        }
                        $scope.banner_list = image_list;

                        $ionicSlideBoxDelegate.update();
                        $ionicSlideBoxDelegate.loop(true);

                        $timeout(function () {
                            $ionicSlideBoxDelegate.update();
                            $ionicSlideBoxDelegate.loop(true);

                            var ids = [];
                            for(var obj in $scope.banner_list){
                                if ($scope.isValid($scope.banner_list[obj].id)){
                                    ids.push($scope.banner_list[obj].id);
                                }
                            }
                            H5jumper.initByIds(ids);

                            $scope.slideDisplay = true;
                        }, 100);
                    };

                    var image_list = [];
                    var imageCount = 0;

                    var onload = function () {
                        imageCount += 1;
                        if (imageCount===image_list.length-1){
                            loadBanners(image_list);
                        }
                    };
                    var onerror = function () {
                        image.src = 'img/banner@2x.png';
                        imageCount += 1;
                        if (imageCount===image_list.length-1){
                            loadBanners(image_list);
                        }
                    };

                    for(var obj in response.data.banner_750X270){
                        var item = angular.copy(response.data.banner_750X270[obj]);
                        item.logo_mid = config.assets_img_domain + item.logo_mid;

                        var image = new window.Image();
                        image.src = item.logo_mid;
                        item.image = image;
                        image_list.push(item);

                        image.onload = onload;
                        image.onerror = onerror;
                    }
                }

                $scope.total = response.data.total;
                if (isForce){
                    $scope.product_list = [];
                }

                if (!$scope.isValid($scope.product_list) || !angular.equals($scope.product_list[$scope.product_list.length-1], response.data.product_list[response.data.product_list.length-1])) {
                    $scope.product_list = $scope.product_list.concat(response.data.product_list);
                }

                if ($scope.isValid(response.data.succ_list)){
                    $scope.UpDownSlide.show(response.data.succ_list);
                }

                $scope.isEnd = $scope.offset === response.data.offset;
                $scope.offset = response.data.offset;
            })
            .error(function (response, status) {
                $scope.isEnd = true;
                $scope.Tips.show(2000, '网络不可用，请检查您的网络设置', function(){
                    // $scope.doRefresh($scope.offset, false);
                });
            })
            .finally(function() {
                $scope.$broadcast('scroll.infiniteScrollComplete');
                $scope.$broadcast('scroll.refreshComplete');
            })
            ;
        };

        $scope.doRefresh(false);
    })

    .controller('ListController', function($window, $scope, $state, $http, $ionicHistory, $stateParams, $ionicModal, $ionicActionSheet, $timeout, $ionicScrollDelegate, config) {
        $scope.config = config;

        $ionicHistory.clearHistory();

        $scope.loop.pauseAllLoop();

        $scope.request = {};
        $scope.request.limit_min = 0;
        $scope.request.limit_max = 0;

        $scope.request.product_tag = $scope.isValid($stateParams.product_tag)?$stateParams.product_tag:"";
        $scope.request.limit = $scope.isValid($stateParams.limit)?$stateParams.limit:'';

        $scope.product_tags = ["急速小贷","大额贷款","学生贷","信用卡代还","新口子","信用卡贷","需淘宝账户","需稳定工作"];
        $scope.limit_amount = ["3000以下","3000-5000","5000-10000","10000以上"];

        if ($scope.request.limit){
            var keys = $scope.request.limit.replace(/[^0-9-]/g, '').split('-');
            $scope.request.limit_min = $scope.request.limit.endsWith('下')?1:parseInt(keys[0]);
            $scope.request.limit_max = $scope.request.limit.endsWith('下')?parseInt(keys[0]):(keys.length===1?10000000000:parseInt(keys[1]));
        }

        $scope.request.USerialID = 0;
        for(var i=0; i<config.client.device.UUID.length; i++){
            $scope.request.USerialID += config.client.device.UUID.charCodeAt(i);
        }

        $scope.request.doFilter = function(){
            var arrays = [];
            for (var i=0; i<$scope.product_list_all.length; i++){
                var product = angular.copy($scope.product_list_all[i]);
                if (($scope.isValid($scope.request.product_tag) && product.product_tags.indexOf($scope.request.product_tag)===-1)){
                    continue;
                }

                product.view_rate = parseFloat(product.view_rate);

                if (product.view_rate>0 && product.view_rate<100){
                    if ($scope.request.USerialID>product.view_rate){
                        continue;
                    }
                }

                product.limit_min = parseInt(product.limit_min);
                product.limit_max = parseInt(product.limit_max);

                if ($scope.request.limit_min>0){
                    if (product.limit_max<$scope.request.limit_min || product.limit_min>$scope.request.limit_max){
                        continue;
                    }
                }

                product.number = parseInt(product.number);
                product.success_rate = parseFloat(product.success_rate);
                product.sort_recommend = parseFloat(product.sort_recommend);
                arrays.push(product);
            }
            $scope.product_list = arrays;

            $ionicScrollDelegate.$getByHandle('listScroll').scrollTop(false);
        };

        $scope.request.order = '-sort_recommend';

        $scope.request.onPlulled = false;
        $scope.product_list_all = [];
        $scope.product_list = [];
        $scope.request.canQuery = true;
        $scope.request.doQuery = function(isForce){
            if (!$scope.request.canQuery){return;}
            $scope.request.canQuery = false;

            if (!isForce && $scope.isValid($scope.product_list)){
                $scope.request.doFilter();
                $scope.request.canQuery = true;
                return;
            }

            var params = {};
            params.app_product_key = config.app_product_key;

            $http({
                timeout: 10000,
                method: 'jsonp',
                url: config.data_domain + "/index.php/product/query?callback=JSON_CALLBACK",
                params: params
            })
            .success(function (response) {
                if (!response.success) {
                    $scope.Tips.show(2000, response.message, null);
                    return;
                }

                if ($scope.isValid(response.data.product_list)) {
                    $timeout(function() {
                        $scope.product_list_all = response.data.product_list;
                        $scope.request.doFilter();
                    }, 100);
                }
            })
            .error(function (response, status) {
                $scope.Tips.show(2000, '网络不可用，请检查您的网络设置', function () {
                    // $scope.request.doQuery($scope.offset, false);
                });
            })
            .finally(function () {
                $scope.$broadcast('scroll.infiniteScrollComplete');
                $scope.$broadcast('scroll.refreshComplete');
                $scope.request.onPlulled = true;
                $scope.request.canQuery = true;
            });
        };

        $scope.switch_view = '';
        $scope.switch_view_name = '';
        $scope.switchViewName = function(tag) {
            $scope.switch_view = tag;
            $scope.switch_view_name = tag;
        };
        $scope.switchView = function(tag){
            if ($scope.switch_view===tag || tag===''){
                if ($scope.isValid($scope.boxModal)){
                    $scope.boxModal.remove();
                    $scope.boxModal = null;
                }
                $scope.switch_view = '';
                return;
            }
            $scope.switch_view = tag;
            $scope.switch_view_name = tag;

            if (!$scope.isValid($scope.boxModal)){
                $ionicModal.fromTemplateUrl('templates/component/list_slide.html', {
                    scope: $scope,
                    animation: 'slide-in-down'
                }).then(function(modal) {
                    $scope.boxModal = modal;
                    $scope.boxModal.show();
                });
            }
        };

        $scope.onSwitchs  = function(key){
            if ($scope.switch_view==='product_tag'){
                $scope.request.product_tag = key;
            }
            if ($scope.switch_view==='limit_max'){
                $scope.request.limit = key;
                if (key){
                    var keys = key.replace(/[^0-9-]/g, '').split('-');
                    $scope.request.limit_min = key.endsWith('下')?1:parseInt(keys[0]);
                    $scope.request.limit_max = key.endsWith('下')?parseInt(keys[0]):(keys.length===1?10000000000:parseInt(keys[1]));
                }else{
                    $scope.request.limit_min = 0;
                    $scope.request.limit_max = 0;
                }
            }
            $scope.request.doQuery(false);
            if ($scope.isValid($scope.boxModal)){
                $scope.boxModal.remove();
                $scope.boxModal = null;
            }
            $scope.switch_view = '';
        };

        if (!$scope.isValid($ionicHistory.currentHistoryId())){
            $scope.goUrl('index', {}, false, true);
        }else{
            $scope.request.doQuery(true);
        }
    })

    .controller('ProductController', function($scope, $state, $http, $ionicHistory, $stateParams, $ionicActionSheet, $ionicLoading, $timeout, config) {
        $ionicLoading.show({
            content: 'Loading',
            animation: 'fade-in',
            showBackdrop: true,
            maxWidth: 200,
            duration: 10000,
            showDelay: 0
        });

        $scope.loop.pauseAllLoop();

        $scope.config = config;

        $scope.focus = {};
        $scope.focusElement = function(valueKey){
            $scope.loop.removeLoop('product_number_keyboard');
            $scope.focus = {};
            $scope.focus[valueKey] = true;
            $scope.loop.addLoop('product_number_keyboard', function(){
                if ($scope.focus[valueKey]){
                    $scope.focus[valueKey] = false;
                }else{
                    $scope.focus[valueKey] = true;
                }
            }, 600);
        };
        $scope.blurElement = function(valueKey){
            if ($scope.isValid(valueKey)){
                $scope.focus[valueKey] = false;
            }else{
                $scope.loop.removeLoop('product_number_keyboard');
                $scope.focus = {};
            }
        };

        $scope.request = {};
        $scope.request.limit = $stateParams.amount?$stateParams.amount:'';
        $scope.timeSelections = [];
        $scope.product = {};
        $scope.brand = {};

        $scope.canQuery = true;
        $scope.releaseRefresher = function() {
            if (!$scope.canQuery){return;}
            $scope.canQuery = false;

            $scope.doRefresh();
            $timeout(function () {
                $scope.$broadcast('scroll.refreshComplete');
                $scope.canQuery = true;
            }, 2500);
        };

        $scope.doRefresh = function() {
            var params = {};
            params.id = $stateParams.id;
            // params['client'] = config.client;
            params.app_product_key = config.app_product_key;

            $http({
                timeout: 10000,
                method: 'jsonp',
                url: config.data_domain + "/index.php/product/?callback=JSON_CALLBACK",
                params: params
            })
            .success(function (response) {
                $timeout(function () {
                    $ionicLoading.hide();
                }, 200);

                if (!response.success) {
                    $scope.Tips.show(2000, response.message, function () {
                        $scope.doBack();
                    });
                    return;
                }

                for (var item in response.data.product) {
                    response.data.product[item] = response.data.product[item].trim().replace(/(\r|\n)+/g, '\n').replace(/\r|\n/g, "<br />");
                }
                for (var item_1 in response.data.brand) {
                    response.data.brand[item_1] = response.data.brand[item_1].trim().replace(/(\r|\n)+/g, '\n').replace(/\r|\n/g, "<br />");
                }
                $scope.product = response.data.product;

                $scope.product.time_selections = response.data.product.time_selection.split(',');
                $scope.brand = response.data.brand;

                $scope.timeSelections = [];
                for (var i = 0; i < $scope.product.time_selections.length; i++) {
                    $scope.timeSelections.push($scope.product.time_selections[i] + ($scope.product.unit === '月' ? '个月' : ($scope.product.unit==='日'?'天':$scope.product.unit)));
                }
                $scope.request.time = $scope.product.time_selections[0];
                $scope.request.unit = $scope.product.unit;
                $scope.request.interest_rate = $scope.product.interest_rate;

                if ($scope.product.product_type === '急速小贷') {
                    if (parseInt($scope.request.limit) > parseInt($scope.product.limit_max)) {
                        $scope.request.limit = $scope.product.limit_max;
                    }
                    if (!$scope.isValid($scope.request.limit) || parseInt($scope.request.limit) < parseInt($scope.product.limit_min)) {
                        $scope.request.limit = $scope.product.limit_min;
                    }
                } else if ($scope.product.product_type === '大额贷款') {
                    if (parseInt($scope.request.limit) > parseInt($scope.product.limit_max)) {
                        $scope.request.limit = $scope.product.limit_max / 10000;
                    }
                    if (!$scope.isValid($scope.request.limit) || parseInt($scope.request.limit) < parseInt($scope.product.limit_min)) {
                        $scope.request.limit = $scope.product.limit_min / 10000;
                    }
                }

                $scope.request.amount = $scope.request.limit * ($scope.product.product_type === '急速小贷' ? 1 : ($scope.product.product_type === '大额贷款' ? 10000 : 1));
                $scope.calculator($scope.request);

            })
            .error(function (response, status) {
                $ionicLoading.hide();
                $scope.Tips.show(2000, '网络不可用，请检查您的网络设置', function () {
                    // $scope.doRefresh();
                });
            })
            .finally(function() {
                $scope.$broadcast('scroll.refreshComplete');
            })
            ;
        };

        $scope.calculator = function(request){
            var principal = parseFloat(request.amount);
            var interest = parseFloat(request.interest_rate)/100;
            var payments = parseFloat(request.time.replace(/\D+/igm,''));

            request.monthly = 0.0;
            if (request.unit==='月'){
                // 现在计算月度赔付的数据
                var x = Math.pow(1 + interest, payments);// Math.pow()进行幂次运算

                request.monthly = (principal*x*interest)/(x-1);

                request.interest = Math.round(request.monthly * payments - principal, 0);
                request.monthly = Math.round(request.monthly);
            }else{
                // 现在计算日度赔付的数据
                // 贷款本金*日利率*天数
                request.interest = Math.round(principal * interest * payments, 0);
            }

            return request;
        };

        $scope.showKeyBoard = function(NumberKeyboard){
            $scope.NumberKeyboard = NumberKeyboard;

            $scope.focusElement('limit');

            $scope.NumberKeyboard.showKeyBoard($scope.request.limit,
                function (keyString){
                    $scope.request.limit = $scope.request.limit?$scope.request.limit:"";

                    if (keyString==="b"){
                        $scope.request.limit += "";
                        if ($scope.request.limit.length>0){
                            $scope.request.limit = $scope.request.limit.substr(0, $scope.request.limit.length-1);
                        }
                        return $scope.request.limit;
                    }
                    if (($scope.request.limit + keyString).length>6){
                        return $scope.request.limit;
                    }

                    $scope.request.limit = $scope.request.limit + keyString;

                    $scope.request.amount = parseFloat($scope.request.limit)*($scope.product.product_type==='急速小贷'?1:($scope.product.product_type==='大额贷款'?10000:1));
                    $scope.calculator($scope.request);

                    return $scope.request.limit;
                },
                function(){
                    $scope.blurElement();
                    $scope.NumberKeyboard.hide();

                    if ($scope.product.product_type==='急速小贷'){
                        if (parseInt($scope.request.limit)>parseInt($scope.product.limit_max)){
                            $scope.request.limit = $scope.product.limit_max;
                        }
                        if (!$scope.isValid($scope.request.limit) || parseInt($scope.request.limit)<parseInt($scope.product.limit_min)){
                            $scope.request.limit = $scope.product.limit_min;
                        }
                    }else if ($scope.product.product_type==='大额贷款'){
                        if (parseInt($scope.request.limit)>parseInt($scope.product.limit_max/10000)){
                            $scope.request.limit = $scope.product.limit_max/10000;
                        }
                        if (!$scope.isValid($scope.request.limit) || parseInt($scope.request.limit)<parseInt($scope.product.limit_min/10000)){
                            $scope.request.limit = $scope.product.limit_min/10000;
                        }
                    }

                    $scope.request.amount = $scope.request.limit*($scope.product.product_type==='急速小贷'?1:($scope.product.product_type==='大额贷款'?10000:1));
                    $scope.calculator($scope.request);
                    return $scope.request.limit;
                },
                function(beforeNumber){
                    $scope.blurElement();

                    $scope.request.limit = beforeNumber;
                    if ($scope.product.product_type==='急速小贷'){
                        if (parseInt($scope.request.limit)>parseInt($scope.product.limit_max)){
                            $scope.request.limit = $scope.product.limit_max;
                        }
                        if (!$scope.isValid($scope.request.limit) || parseInt($scope.request.limit)<parseInt($scope.product.limit_min)){
                            $scope.request.limit = $scope.product.limit_min;
                        }
                    }else if ($scope.product.product_type==='大额贷款'){
                        if (parseInt($scope.request.limit)>parseInt($scope.product.limit_max/10000)){
                            $scope.request.limit = $scope.product.limit_max/10000;
                        }
                        if (!$scope.isValid($scope.request.limit) || parseInt($scope.request.limit)<parseInt($scope.product.limit_min/10000)){
                            $scope.request.limit = $scope.product.limit_min/10000;
                        }
                    }
                });
        };

        $scope.show_time = false;
        $scope.showTimeSelection = function(Selection){
            $scope.show_time = true;
            if ($scope.isValid($scope.NumberKeyboard)){
                $scope.NumberKeyboard.hideKeyBoard();
            }
            if (!$scope.isValid($scope.timeSelections)){
                $scope.show_time = false;
                return;
            }
            Selection.show($scope.timeSelections, function(index){
                $scope.show_time = false;
                if (index===-1){
                    return true;
                }
                $scope.request.time = $scope.product.time_selections[index];

                $scope.request.amount = $scope.request.limit*($scope.product.product_type==='急速小贷'?1:($scope.product.product_type==='大额贷款'?10000:1));
                $scope.calculator($scope.request);
                return true;
            });
        };

        $scope.targetUrl = '';
        $scope.submitApplication = function(H5jumper, UserAuthen, Confirm){
            $ionicLoading.show({
                content: 'Loading',
                animation: 'fade-in',
                showBackdrop: true,
                maxWidth: 200,
                duration: 10000,
                showDelay: 0
            });

            var params = {};
            params.id = $scope.product.id;
            params.brand_name = $scope.brand.single_name;
            params.product_type = $scope.product.product_type;
            params.product_name = $scope.product.name;
            params.interface_type = $scope.product.interface_type;
            params.interface_content = $scope.product.interface_content;
            params.amount = $scope.request.limit*($scope.product.product_type==='急速小贷'?1:($scope.product.product_type==='大额贷款'?10000:1));
            params.time_limit = ""+$scope.request.time + ($scope.product.unit==='月'?'个':'')+$scope.product.unit;
            params.product_type = $scope.product.product_type;
            params.crowds = $scope.product.crowd.split(',');
            params.crowd = $scope.request.crowd;
            params.crowd = $scope.isValid(params.crowd)?params.crowd: ($scope.isValid(UserAuthen)?UserAuthen.base.crowd:'');
            params.full_name = UserAuthen.base.full_name;
            params.city = UserAuthen.base.city;

            $scope.addApplication = function(){
                $scope.application = {};
                $scope.application[config.TOKEN_NAME] = $scope.getToken(true);

                $scope.application.product_id = params.id;
                $scope.application.amount = params.amount;
                $scope.application.time_limit = params.time_limit;
                $scope.application.serial_id = UserAuthen.base.serial_id;
                $scope.application.client = config.client;
                $scope.application.full_name = params.full_name;
                $scope.application.crowd = params.crowd;
                $scope.application.city = params.city;
                $scope.application.client = config.client;
                $scope.application.app_product_key = config.app_product_key;

                $http({
                    timeout: 10000,
                    method: 'jsonp',
                    url: config.data_domain + "/index.php/application/add?callback=JSON_CALLBACK",
                    params: $scope.application
                })
                .success(function(response) {
                    $scope.getToken(response);
                    $scope.targetUrl = response.data&&response.data.RedirectUrl?response.data.RedirectUrl:$scope.product.interface_content;

                    if (response.success) {
                        UserAuthen.setUserInfo("full_name", $scope.application.full_name);
                        UserAuthen.setUserInfo("city", $scope.application.city);
                        UserAuthen.setUserInfo("crowd", $scope.application.crowd);
                    }else{
                        if (response.code===2 && response.message){
                            $scope.targetUrl = '';
                            Confirm.show('提示', response.message, function(){$scope.doBack();});
                        }else{
                            $scope.Tips.show(1000, response.message, null);
                        }
                    }
                })
                .error(function(response, status) {
                })
                .finally(function() {
                    if ($scope.isValid($scope.targetUrl)) {
                        $timeout(function () {
                            var winParams = {};
                            winParams.brand_name = $scope.brand.single_name;
                            winParams.product_type = $scope.product.product_type;
                            winParams.product_name = $scope.product.name;
                            winParams.interface_type = $scope.product.interface_type;
                            winParams.interface_content = $scope.targetUrl;
                            H5jumper.openWindow(winParams);
                        }, 1);
                    }
                    $ionicLoading.hide();
                })
            ;
            };

            if (params.interface_type.startsWith('H5')) {
                if (!$scope.isValid(UserAuthen) || !UserAuthen.isLogin() || !$scope.isValid(params.full_name) || !$scope.isValid(params.crowd) || !$scope.isValid(params.city)){
                    $scope.goUrl("login_pane", {'params' : angular.toJson(angular.fromJson(params))});
                    $ionicLoading.hide();
                    return;
                }
                $scope.addApplication();
            }else{
                $scope.goUrl("application", params);
                $ionicLoading.hide();
            }
        };

        $scope.doRefresh(false);
    })

    .controller('LoginPaneController', function($scope, $stateParams, $timeout, $http, $ionicLoading, $ionicScrollDelegate,productService, config) {
        $scope.params = angular.fromJson($stateParams.params);
        $scope.params = $scope.isValid($scope.params)?$scope.params:{};
        $scope.params.crowds = ["工薪族","学生","企业主","个体户","无固定职业"];
        $scope.params.crowds = $scope.isValid($scope.params.crowds)?$scope.params.crowds:$scope.crowds;
        $scope.params.crowd = $scope.isValid($scope.params.crowd)?$scope.params.crowd: ($scope.isValid($scope.UserAuthen)?$scope.UserAuthen.base.crowd:'');

        $scope.params.full_name = $scope.isValid($scope.UserAuthen)?$scope.UserAuthen.base.full_name:'';
        $scope.params.city = $scope.isValid($scope.UserAuthen)?$scope.UserAuthen.base.city:'';

        $scope.params.md5 = md5;
        $scope.params.scroll = function(isLeftRight){
            $ionicScrollDelegate.$getByHandle('avaterScrollHandler').scrollBy(isLeftRight?-1000:1000, 0, true);
        };

        $scope.onChooseCity = function(city){$scope.params.city = city;};

        $scope.product = '';
        $scope.brand = '';
        productService.getProductById($scope.params.id, function(data){
            $scope.product = data.product;
            $scope.brand = data.brand;
        });

        $scope.params.submitApplication = function(H5jumper, UserAuthen){
            if (!$scope.isValid($scope.params.full_name)){
                $scope.Tips.show(1000, '请输入真实姓名', function(){UserAuthen.focus.full_name = true; $scope.params.full_name='';});
                return false;
            }
            if (!/^[\u4E00-\u9FA5]{2,32}$/igm.test($scope.params.full_name)){
                $scope.Tips.show(1000, '姓名输入有误', function(){UserAuthen.focus.full_name = true; $scope.params.full_name='';});
                return false;
            }
            if (!$scope.isValid($scope.params.crowd)){
                $scope.Tips.show(1000, '请选择身份', null);
                return false;
            }
            if (!$scope.isValid($scope.params.city)){
                $scope.Tips.show(1000, '请选择所在城市', null);
                return false;
            }
            if (!$scope.isValid($scope.product) || !$scope.isValid($scope.brand)){
                productService.getProductById($scope.params.id, function(data){
                    $scope.product = data.product;
                    $scope.brand = data.brand;
                });
                $scope.Tips.show(1000, '产品信息有误,请重新提交.', null);
                return false;
            }

            $ionicLoading.show({
                content: 'Loading',
                animation: 'fade-in',
                showBackdrop: true,
                maxWidth: 200,
                duration: 10000,
                showDelay: 0
            });

            $scope.loop.removeLoop('number_keyboard', UserAuthen.text_cursor = {});
            if (UserAuthen.isLogin()){
                $scope.addApplication(H5jumper, UserAuthen);
            }else {
                UserAuthen.UserAuthenCode(function () {
                    $scope.addApplication(H5jumper, UserAuthen);
                }, false);
            }
        };

        $scope.requesting = false;
        $scope.targetUrl = '';
        $scope.addApplication = function(H5jumper, UserAuthen, Confirm){
            if ($scope.requesting || $scope.isDone){return;}
            $scope.requesting = true;

            $scope.application = {};
            $scope.application[config.TOKEN_NAME] = $scope.getToken(true);

            $scope.application.product_id = $scope.params.id;
            $scope.application.crowd = $scope.params.crowd;
            $scope.application.city = $scope.params.city;
            $scope.application.full_name = $scope.params.full_name;
            $scope.application.amount = $scope.params.amount;
            $scope.application.time_limit = $scope.params.time_limit;
            $scope.application.serial_id = UserAuthen.base.serial_id;
            $scope.application.client = config.client;
            $scope.application.app_product_key = config.app_product_key;

            $http({
                timeout: 10000,
                method: 'jsonp',
                url: config.data_domain + "/index.php/application/add?callback=JSON_CALLBACK",
                params: $scope.application
            })
            .success(function(response) {
                $scope.getToken(response);
                $scope.targetUrl = response.data&&response.data.RedirectUrl?response.data.RedirectUrl:$scope.product.interface_content;

                if (response.success){
                    UserAuthen.setUserInfo("full_name", $scope.params.full_name);
                    UserAuthen.setUserInfo("city", $scope.params.city);
                    UserAuthen.setUserInfo("crowd", $scope.params.crowd);
                }else{
                    if (response.code===2){
                        $scope.targetUrl = '';
                        Confirm.show('提示', response.message, function(){$scope.doBack();$timeout(function () {$scope.doBack()}, 100);}, function(){$scope.doBack();});
                    }else{
                        $scope.Tips.show(1000, response.message, null);
                    }
                    $scope.Tips.show(1000, response.message, null);
                }
            })
            .error(function(response, status) {
            })
            .finally(function() {
                $ionicLoading.hide();
                if ($scope.isValid($scope.targetUrl)) {
                    $timeout(function () {
                        var winParams = {};
                        winParams.brand_name = $scope.brand.single_name;
                        winParams.product_type = $scope.product.product_type;
                        winParams.product_name = $scope.product.name;
                        winParams.interface_type = $scope.product.interface_type;
                        winParams.interface_content = $scope.targetUrl;
                        H5jumper.openWindow(winParams);
                    }, 1);
                    UserAuthen.doBack();
                }
                $scope.requesting = false;
            })
            ;
        };
    })

    .controller('H5PageController', function($scope, $state, $stateParams, $sce, $ionicHistory , config) {
        $scope.loop.pauseAllLoop();

        var defaultScale = 0.5;
        function fixScreen(scale) {
            var oldMetaEl = document.querySelector('meta[name="viewport"]');

            var metaCtt = metaEl ? metaEl.content : '';
            var matchScale = parseFloat(metaCtt.match(/initial\-scale=([\d\.]+)/));
            if (parseFloat(scale)===matchScale){
                return;
            }

            var metaEl = document.createElement('meta');
            metaEl.name = 'viewport';
            metaEl.content = 'initial-scale='+scale+', minimum-scale='+scale+', maximum-scale='+scale+', user-scalable=no, width=device-width';
            document.documentElement.firstElementChild.appendChild(metaEl);

            oldMetaEl.remove();
        }
        fixScreen(1.0);

        $scope.url = $sce.trustAsResourceUrl($stateParams.interface_content);
        $scope.brand_name = $stateParams.brand_name;
        $scope.product_name = $stateParams.product_name;
        $scope.id = $stateParams.id;
        $scope.amount = $stateParams.amount;
        $scope.time_limit = $stateParams.time_limit;

        $scope.historyLength = history.length;
        $scope.doBack = function() {
            $scope.Tips.hide();
            fixScreen(0.5);

            if ($ionicHistory.backView()) {
                $ionicHistory.goBack();
            }else{
                history.go($scope.historyLength-history.length-1);
            }
        };
    })

    .controller('H5jumpController', function($scope, $state, $stateParams, $http, config) {

        $scope.loop.pauseAllLoop();

        $scope.H5jumper = {};
        $scope.H5jumper.params = {};
        $scope.H5jumper.initByIds = function(ids) {
            if (!$scope.isValid(ids)){return;}
            var params = {};
            params.ids = ids.join(',');
            params.app_product_key = config.app_product_key;

            $http({
                timeout: 10000,
                cache: true,
                method: 'jsonp',
                url: config.data_domain + "/index.php/product/ids?callback=JSON_CALLBACK",
                params: params
            })
            .success(function (response) {
                if (response.success){
                    for(var obj in response.data){
                        $scope.H5jumper.setParams(obj, response.data[obj].brand, response.data[obj].product);
                    }
                }
            });
        };

        $scope.H5jumper.setParams = function(id, product, brand) {
            $scope.H5jumper.params[id] = {};
            $scope.H5jumper.params[id].brand_name = brand.single_name;
            $scope.H5jumper.params[id].product_type = product.product_type;
            $scope.H5jumper.params[id].product_name = product.name;
            $scope.H5jumper.params[id].interface_type = product.interface_type;
            $scope.H5jumper.params[id].interface_content = product.interface_content;
        };

        $scope.H5jumper.openWindowById = function(id, url, title, interface_type) {
            var params = {};
            params.interface_type = $scope.isValid(interface_type)?interface_type:'';
            if ($scope.isValid(id) && $scope.isValid(url)){
                params.id = id;
                params.brand_name = title;
                params.product_name = title;
                // params.interface_type = '';
                params.interface_content = url;
                $scope.goUrl(url, params);
            }else if ($scope.isValid(url)){
                // params.id = id;
                params.brand_name = title;
                params.product_name = title;
                // params.interface_type = '';
                params.interface_content = url;
                $scope.H5jumper.openWindow(params);
            }else if ($scope.isValid($scope.H5jumper.params[id])){
                $scope.H5jumper.openWindow($scope.H5jumper.params[id]);
            }
        };
        $scope.H5jumper.openWindow = function(params) {
            if ($scope.H5jumper.window){$scope.H5jumper.window.close();$scope.H5jumper.window=null;}

            if (!window.cordova || !window.cordova.ThemeableBrowser) {
                $scope.goUrl("h5page", params);
            } else {
                $scope.H5jumper.window = window.cordova.ThemeableBrowser.open(params.interface_content, params.interface_type.startsWith('H5_OUT')?'_system':'_blank', {
                    statusbar: {
                        color: '#FA9400FF',
                        backgroundColor: '#FA9400FF'
                    },
                    toolbar: {
                        height: config.isApple ? 36 : 44,
                        color: '#FA9400FF',
                        backgroundColor: '#FA9400FF'
                    },
                    title: {
                        color: '#FFFFFFFF',
                        staticText: params.product_name,
                        fontSize: config.isApple?42:18
                    },
                    backButton: {
                        wwwImage: 'img/icon_fanhui_close_window'+(config.isApple?'@2x':'')+'.png',
                        wwwImagePressed: 'img/icon_fanhui_close_window'+(config.isApple?'@2x':'')+'.png',
                        wwwImageDensity: 2,
                        align: 'left',
                        event: 'backPressed',
                        //backgroundColor: '#FA9400FF'
                    },
                    closeButton: {
                        // wwwImage: 'img/icon_fanhui_close_window'+(config.isApple?'@2x':'')+'.png',
                        // wwwImagePressed: 'img/icon_fanhui_close_window'+(config.isApple?'@2x':'')+'.png',
                        // wwwImageDensity: 2,
                        text: '关闭',
                        align: 'left',
                        event: 'closePressed',
                        //backgroundColor: '#FA9400FF'
                    },
                    backButtonCanClose: true,
                    fullscreen: false,
                    disableAnimation: false,
                }).addEventListener('closePressed', function (e) {
                    // win.close();
                }).addEventListener(window.cordova.ThemeableBrowser.EVT_ERR, function (e) {
                    console.error(e.message);
                }).addEventListener(window.cordova.ThemeableBrowser.EVT_WRN, function (e) {
                    console.log(e.message);
                });
            }
        };
    })

    .controller('ApplicationController', function($scope, $http, $state, $stateParams, $ionicModal, $ionicActionSheet, $ionicScrollDelegate, $ionicLoading, $ionicHistory, config) {
        $ionicLoading.show({
            content: 'Loading',
            animation: 'fade-in',
            showBackdrop: true,
            maxWidth: 200,
            duration: 10000,
            showDelay: 0
        });

        $scope.step = 0;

        $scope.application = {};
        $scope.application.product_id = $stateParams.id;
        $scope.application.amount = $stateParams.amount;
        $scope.application.time_limit = $stateParams.time_limit;
        $scope.application.product_type = $stateParams.product_type;
        $scope.application.crowd = $stateParams.crowd;

        $scope.UserAuthen = '';
        $scope.Selection = '';
        $scope.setComponent = function(argsUserAuthen, argsSelection){
            $scope.Selection = argsSelection;
            if (!$scope.isValid($scope.UserAuthen)){
                $scope.UserAuthen = argsUserAuthen;
                $scope.UserAuthen.doLogin();

                $scope.application.full_name = $scope.UserAuthen.base.full_name;
                $scope.application.city = $scope.UserAuthen.base.city;
                $scope.application.crowd = $scope.UserAuthen.base.crowd;
                $scope.application.id_number = $scope.UserAuthen.base.id_number;
                $scope.application.credit_status = $scope.UserAuthen.base.credit_status;
                $scope.application.is_marriage = $scope.UserAuthen.base.is_marriage;

                $scope.doRefresh();
            }
        };

        $scope.focus = {};
        $scope.focusElement = function(valueKey){
            $scope.loop.removeLoop('application_number_keyboard');
            $scope.focus = {};
            $scope.focus[valueKey] = true;
            $scope.loop.addLoop('application_number_keyboard', function(){
                if ($scope.focus[valueKey]){
                    $scope.focus[valueKey] = false;
                }else{
                    $scope.focus[valueKey] = true;
                }
            }, 600);
        };
        $scope.blurElement = function(valueKey){
            if ($scope.isValid(valueKey)){
                $scope.focus[valueKey] = false;
            }else{
                $scope.loop.removeLoop('application_number_keyboard');
                $scope.focus = {};
            }
        };

        $scope.product = {};

        $scope.doRefresh = function(){
            $ionicLoading.show({
                content: 'Loading',
                animation: 'fade-in',
                showBackdrop: true,
                maxWidth: 200,
                duration: 10000,
                showDelay: 0
            });

            var params = {};
            params.product_id = $stateParams.id;
            params.app_product_key = config.app_product_key;
            if ($scope.isValid($scope.UserAuthen) && $scope.isValid($scope.UserAuthen.base)){
                params.serial_id = $scope.UserAuthen.base.serial_id;
            }

            $http({
                timeout: 10000,
                method: 'jsonp',
                url: config.data_domain + "/index.php/application/last?callback=JSON_CALLBACK",
                params: params
            })
            .success(function (response) {
                if (response.success){
                    if ($scope.isValid(response.data)){
                        $scope.product = response.data.product;

                        if ($scope.product.product_type==="大额贷款"){
                            $scope.crowds = ["请选择", "工薪族","企业主","个体户","无固定职业"];
                            $scope.showCrowds = $scope.initSelection('crowd', $scope.crowds);
                        }
                    }
                    if ($scope.isValid(response.data)){
                        for(var item in response.data.application){
                            if ($scope.isValid(response.data.application[item])){
                                $scope.application[item] = response.data.application[item]=='0'?'':response.data.application[item];
                            }
                        }
                    }

                    $scope.application.crowd = $scope.isValid($scope.application.crowd)&&$scope.crowds.indexOf($scope.application.crowd)>-1?$scope.application.crowd:$scope.crowds[0];
                // }else{
                //     $scope.Tips.show(2000, response.message, null);
                }
            })
            .error(function () {
                $scope.Tips.show(2000, '网络不可用，请检查您的网络设置', function () {
                    // $scope.doRefresh();
                });
            })
            .finally(function() {
                $ionicLoading.hide();
            })
            ;
        };

        $scope.initSelection = function(key, defaultSelections){
            return function() {
                if ($scope.isValid($scope.NumberKeyboard)){
                    $scope.NumberKeyboard.hideKeyBoard();
                }
                if (!$scope.isValid(defaultSelections)){return;}
                $scope.Selection.show(defaultSelections, function(index){
                    if (index===-1){return true;}

                    $scope.application[key] = defaultSelections[index];
                    return true;
                });
            };
        };

        $scope.application.full_name = "";
        $scope.application.id_number = "";
        $scope.application.amount_total = '';
        $scope.application.amount_public = '';
        $scope.application.income = '';

        $scope.validate = {};
        $scope.validate.full_name = function(){
            $scope.application.full_name = $scope.application.full_name.trim();

            if (!$scope.isValid($scope.application.full_name)){
                $scope.Tips.show(1000, '请输入姓名', function (){$scope.focus.full_name = true;});
                return false;
            }
            if (!/^[\u4E00-\u9FA5]{2,32}$/igm.test($scope.application.full_name)){
                $scope.Tips.show(1000, '姓名输入有误', function (){$scope.focus.full_name = true;});
                return false;
            }
            return true;
        };

        $scope.validate.id_number = function(){
            $scope.application.id_number = $scope.application.id_number.trim();

            if (!$scope.isValid($scope.application.id_number)){
                $scope.Tips.show(1000, '请输入身份证号', function (){$scope.focus.id_number = true;});
                return false;
            }
            if (!IdentityCodeValid($scope.application.id_number)){
                $scope.Tips.show(1000, '身份证号输入有误', function (){$scope.focus.id_number = true;});
                return false;
            }
            return true;
        };
        $scope.validate.amount_total = function(){
            $scope.application.amount_total = $scope.application.amount_total.trim();

            if (!$scope.isValid($scope.application.amount_total)){
                $scope.focusElement('amount_total');
                $scope.Tips.show(1000, '请输入总经营流水', function (){$scope.focus.amount_total = true;});
                return false;
            }
            if (parseFloat($scope.application.amount_total)<=0){
                $scope.focusElement('amount_total');
                $scope.Tips.show(1000, '总经营流水输入有误', function (){$scope.application.amount_total = '';});
                return false;
            }
            return true;
        };
        $scope.validate.amount_public = function(){
            $scope.application.amount_public = $scope.application.amount_public.trim();

            if (!$scope.isValid($scope.application.amount_public)){
                $scope.focusElement('amount_public');
                $scope.Tips.show(1000, '请输入对公账户经营收入', function (){$scope.focus.amount_public = true;});
                return false;
            }
            if (parseFloat($scope.application.amount_public)<=0){
                $scope.focusElement('amount_public');
                $scope.Tips.show(1000, '对公账户经营收入输入有误', function (){$scope.application.amount_public = '';});
                return false;
            }
            return true;
        };
        $scope.validate.income = function(){
            $scope.application.income = $scope.application.income.trim();

            if (!$scope.isValid($scope.application.income)){
                $scope.focusElement('income');
                $scope.Tips.show(1000, '请输入每月收入', function (){$scope.focus.income = true;});
                return false;
            }
            if (parseFloat($scope.application.income)<=0){
                $scope.focusElement('income');
                $scope.Tips.show(1000, '每月收入输入有误', function (){$scope.application.income = '';});
                return false;
            }
            return true;
        };


        $scope.validate.house_value = function(){
            if ($scope.application.asset_house!==$scope.assetHouse[$scope.assetHouse.length-1]) {
                $scope.application.house_value = $scope.application.house_value.trim();

                if (!$scope.isValid($scope.application.house_value)){
                    $scope.focusElement('house_value');
                    $scope.Tips.show(1000, '请输入房产估值', function (){$scope.focus.house_value = true;});
                    return false;
                }
                if (parseFloat($scope.application.house_value)<=0){
                    $scope.focusElement('house_value');
                    $scope.Tips.show(1000, '房产估值输入有误', function () { $scope.application.house_value = ''; });
                    return false;
                }
            }else{
                $scope.application.is_house_mortgage = $scope.isHouseMortgage[$scope.isHouseMortgage.length-1];
            }
            return true;
        };

        $scope.validate.car_value = function(){
            if ($scope.application.asset_car!==$scope.assetCar[$scope.assetCar.length-1]) {
                $scope.application.car_value = $scope.application.car_value.trim();

                if (!$scope.isValid($scope.application.car_value)){
                    $scope.focusElement('car_value');
                    $scope.Tips.show(1000, '请输入车辆估值', function (){$scope.focus.car_value = true;});
                    return false;
                }
                if (parseFloat($scope.application.house_value)<=0){
                    $scope.focusElement('car_value');
                    $scope.Tips.show(1000, '车辆估值输入有误', function () { $scope.application.car_value = ''; });
                    return false;
                }
            }else{
                $scope.application.is_car_mortgage = $scope.isCarMortgage[$scope.isCarMortgage.length-1];
            }
            return true;
        };

        $scope.goHeight = 0;
        $scope.showKeyBoard = function(NumberKeyboard, valueKey, height){
            $ionicScrollDelegate.$getByHandle('applicationScroll').scrollTop(true);

            $scope.NumberKeyboard = NumberKeyboard;
            if (height>0){
                $scope.goHeight = ((window.screen.height*2 - height) - $scope.NumberKeyboard.height);
                if ($scope.goHeight>0){
                    $scope.goHeight = 0;
                }
            }else{
                $scope.goHeight = 0;
            }

            $scope.focusElement(valueKey);

            $scope.NumberKeyboard.showKeyBoard($scope.application[valueKey],
                function (keyString){
                    $scope.application[valueKey] = $scope.isValid($scope.application[valueKey])?$scope.application[valueKey]:"";

                    if (keyString==="b"){
                        $scope.application[valueKey] += "";
                        if ($scope.isValid($scope.application[valueKey])){
                            $scope.application[valueKey] = $scope.application[valueKey].substr(0, $scope.application[valueKey].length-2);
                        }
                        return $scope.application[valueKey];
                    }

                    return $scope.application[valueKey] += keyString;
                },
                function(){
                    $scope.application[valueKey] = $scope.isValid($scope.application[valueKey])?$scope.application[valueKey]:"";

                    if (!$scope.validate[valueKey]()){
                        $scope.application[valueKey] = '';
                    }
                    return $scope.application[valueKey];
                },
                function(beforeNumber){
                    $scope.NumberKeyboard.hide();
                });
        };

        $scope.city_name = "所在城市";
        $scope.application.city = "请选择";

        $scope.onChooseCity = function(city){$scope.application.city=city;};

        $scope.isMarriage = ["未婚","已婚"];
        $scope.is_marriage_name = "婚姻状况";
        $scope.application.is_marriage = $scope.isMarriage[0];
        $scope.showIsMarriage = $scope.initSelection('is_marriage', $scope.isMarriage);

        $scope.crowds = ["请选择", "工薪族","学生","企业主","个体户","无固定职业"];
        if ($scope.product.product_type==="大额贷款"){$scope.crowds = ["请选择", "工薪族","企业主","个体户","无固定职业"];}
        $scope.crowd_name = '职业身份';
        $scope.application.crowd = $scope.isValid($scope.application.crowd)&&$scope.crowds.indexOf($scope.application.crowd)>-1?$scope.application.crowd:$scope.crowds[0];
        $scope.showCrowds = $scope.initSelection('crowd', $scope.crowds);

        $scope.creditStatus = ["请选择", "无信用卡和贷款", "信用良好", "1年内逾期少于3次且少于90天", "1年内逾期超过3次或超过90天"];
        $scope.credit_status_name = '信用状况';
        $scope.application.credit_status = $scope.creditStatus[0];
        $scope.showCreditStatus = $scope.initSelection('credit_status', $scope.creditStatus);

        $scope.uses = ["请选择", "短期资金","购房贷款","汽车消费","住房装修","个人旅游","教育培训","网购贷款","其他用途"];
        $scope.use_name = '贷款用途';
        $scope.application.use = $scope.uses[0];
        $scope.showUses = $scope.initSelection('use', $scope.uses);

        $scope.yearss = ["请选择", "不足3个月", "3个月", "半年", "1年","2年", "3年", "4年", "5年及以上"];
        $scope.years_name = '经营年限';
        $scope.application.years = $scope.yearss[0];
        $scope.showYears = $scope.initSelection('years', $scope.yearss);

        $scope.cityRegister = ["本地","外地"];
        $scope.application.city_register = $scope.cityRegister[0];
        $scope.showCityRegister = $scope.initSelection('city_register', $scope.cityRegister);

        $scope.isLicenses = ["请选择", "没办理","已办理，注册不满6个月","已办理，注册6~11月","已办理，注册满1年","已办理，注册满2年","已办理，注册满3年","已办理，注册满4年","已办理，注册满5年及以上"];
        $scope.is_license_name = '是否办理过营业执照';
        $scope.application.is_license = $scope.isLicenses[0];
        $scope.showIsLicense = $scope.initSelection('is_license', $scope.isLicenses);

        $scope.wagess = ["请选择", "银行代发","转账工资","现金发放"];
        $scope.wages_name = '收入形式';
        $scope.application.wages = $scope.wagess[0];
        $scope.showWages = $scope.initSelection('wages', $scope.wagess);

        $scope.timeWorkings = ["请选择", "不足3个月","3~5个月","6~11个月","1~3年","4~7年","7年以上"];
        $scope.time_working_name = '当前公司工作时间';
        $scope.application.time_working = $scope.timeWorkings[0];
        $scope.showTimeWorkings = $scope.initSelection('time_working', $scope.timeWorkings);

        $scope.socialSecurity = ["有","无"];
        $scope.application.social_security = $scope.socialSecurity[0];
        $scope.showSocialSecurity = $scope.initSelection('social_security', $scope.socialSecurity);

        $scope.providentFund = ["有","无"];
        $scope.application.provident_fund = $scope.providentFund[0];
        $scope.showProvidentFund = $scope.initSelection('provident_fund', $scope.providentFund);

        $scope.assetHouse = ["请选择", "有房，未抵押","有房，已抵押","无房"];
        $scope.asset_house_name = '名下房产';
        $scope.application.asset_house = $scope.assetHouse[0];
        $scope.showAssetHouse = $scope.initSelection('asset_house', $scope.assetHouse);

        $scope.isHouseMortgage = ["是","否"];
        $scope.application.is_house_mortgage = $scope.isHouseMortgage[0];
        $scope.showIsHouseMortgage = $scope.initSelection('is_house_mortgage', $scope.isHouseMortgage);

        $scope.houseType = ["请选择", "商品住宅","商铺","办公楼","厂房","经适/限价房","房改/危改房","其他"];
        $scope.house_type_name = '名下房产类型';
        $scope.application.house_type = $scope.houseType[0];
        $scope.showHouseType = $scope.initSelection('house_type', $scope.houseType);

        $scope.assetCar = ["请选择", "有车产，未抵押","有车产，已抵押","无车，准备购买","无车"];
        $scope.asset_car_name = '名下车产';
        $scope.application.asset_car = $scope.assetCar[0];
        $scope.showAssetCar = $scope.initSelection('asset_car', $scope.assetCar);

        $scope.isCarMortgage = ["是","否"];
        $scope.application.is_car_mortgage = $scope.isCarMortgage[0];
        $scope.showIsCarMortgage = $scope.initSelection('is_car_mortgage', $scope.isCarMortgage);

        $scope.checkSelection = function(list){
            for (var item in list){
                if ($scope.application[list[item]]==='请选择' || $scope.application[list[item]]===''){
                    $scope.Tips.show(1000, '请选择 ['+$scope[list[item]+'_name']+']', null);
                    return false;
                }
            }
            return true;
        };

        $scope.requesting = false;
        $scope.isDone = false;
        $scope.nextTabs = function(index){
            if ($scope.step+1!==index){
                $ionicScrollDelegate.$getByHandle('applicationScroll').scrollTop();
            }

            if (!$scope.isValid($scope.UserAuthen.mobile)){
                $scope.Tips.show(1000, '请输入手机号', null);
                return;
            }
            if (!$scope.isValid($scope.UserAuthen) || !$scope.UserAuthen.isLogin()){
                $scope.Tips.show(1000, '请输入验证码', null);
                return;
            }

            if (index===-1){
                $scope.step -= 1;
                if ($scope.application.crowd==='学生'){
                    $scope.step = 0;
                }
                return;
            }

            if ($scope.step===0){
                if (!$scope.validate.full_name() || !$scope.validate.id_number()){
                    return;
                }

                if (!$scope.checkSelection(['crowd', 'credit_status', 'city', 'use'])){
                    return;
                }

                if ($scope.application.crowd==='学生'){
                    $scope.step = 2;
                    return;
                }
            }

            if ($scope.step===1){
                if ($scope.application.crowd==='企业主' || $scope.application.crowd==='个体户'){

                    if (!$scope.validate.amount_total()){
                        return;
                    }
                    if (!$scope.validate.amount_public()){
                        return;
                    }

                    if (!$scope.checkSelection(['years', 'is_license'])){
                        return;
                    }
                }

                if ($scope.application.crowd==='无固定职业'){
                    if (!$scope.checkSelection(['wages'])){
                        return;
                    }
                    if (!$scope.validate.income()){
                        return;
                    }
                }
                if ($scope.application.crowd==='工薪族'){
                    if (!$scope.checkSelection(['wages', 'time_working'])){
                        return;
                    }
                    if (!$scope.validate.income()){
                        return;
                    }
                }
            }

            if ($scope.step===2) {
                if (!$scope.checkSelection(['asset_house'])){
                    return;
                }
                if (!$scope.validate.house_value()) {
                    return;
                }
                if (!$scope.checkSelection(['asset_car'])){
                    return;
                }
                if (!$scope.validate.car_value()) {
                    return;
                }
            }

            if ($scope.step===2) {
                if ($scope.requesting || $scope.isDone){return;}
                $scope.requesting = true;

                if ($scope.application.crowd==='企业主' || $scope.application.crowd==='个体户'){
                    $scope.application.time_working = '请选择';
                    $scope.application.wages = '请选择';
                    $scope.application.income = '';
                }

                if ($scope.application.crowd==='无固定职业'){
                    $scope.application.amount_total = '';
                    $scope.application.amount_public = '';
                    $scope.application.years = '请选择';
                    $scope.application.is_license = '请选择';
                }
                if ($scope.application.crowd==='工薪族'){
                    $scope.application.amount_total = '';
                    $scope.application.amount_public = '';
                    $scope.application.years = '请选择';
                    $scope.application.is_license = '请选择';
                }

                $scope.application[config.TOKEN_NAME] = $scope.getToken(true);

                var params = angular.copy($scope.application);
                params.serial_id = $scope.UserAuthen.base.serial_id;
                params.client = config.client;
                params.app_product_key = config.app_product_key;
                for (var item in params){
                    if (params[item]==='请选择'){
                        params[item] = '';
                    }
                }

                $http({
                    timeout: 10000,
                    method: 'jsonp',
                    url: config.data_domain + "/index.php/application/add?callback=JSON_CALLBACK",
                    params: params
                })
                .success(function(response) {
                    $scope.getToken(response);
                    if (response.success){
                        $ionicHistory.clearHistory();
                        $scope.isDone = true;
                        $scope.step = 0;
                        $scope.goUrl('application_success');

                        $scope.UserAuthen.setUserInfo("full_name", $scope.application.full_name);
                        $scope.UserAuthen.setUserInfo("city", $scope.application.city);
                        $scope.UserAuthen.setUserInfo("crowd", $scope.application.crowd);

                        // $scope.Tips.show(1000, '请求成功', function (){ $scope.goUrl('application_success');});
                    }else{
                        $scope.Tips.show(2000, response.message, null);
                    }
                    // $scope.goUrl("responsePage", angular.fromJson({"success":false,"message": "好像断网咯？"}));
                })
                .error(function(response, status) {
                    $scope.Tips.show(2000, '网络不可用，请检查您的网络设置', null);
                })
                .finally(function() {
                    $scope.requesting = false;
                })
                ;
                return;
            }
            $scope.step += index;
        };

    })

    .controller('ApplicationListController', function($scope, $http, $state, $ionicLoading, $window, config) {
        $scope.application_list= [];
        $scope.brand_list = {};
        $scope.product_list = {};

        $scope.queried = false;
        $scope.applyQuery = function(H5jumper, id){
            for(var item in $scope.application_list){
                H5jumper.setParams(
                    $scope.application_list[item].product_id,
                    $scope.product_list[$scope.application_list[item].product_id],
                    $scope.brand_list[$scope.product_list[$scope.application_list[item].product_id].brand_id]);
            }

            H5jumper.openWindowById(id, null, null, null);
        };

        $scope.initData = function(UserAuthen) {

            $ionicLoading.show({
                content: 'Loading',
                animation: 'fade-in',
                showBackdrop: true,
                maxWidth: 200,
                duration: 10000,
                showDelay: 0
            });

            var params = {};
            params.serial_id = UserAuthen.base.serial_id;
            // params.client = config.client;
            params.app_product_key = config.app_product_key;

            $http({
                timeout: 10000,
                method: 'jsonp',
                url: config.data_domain + "/index.php/application/query?callback=JSON_CALLBACK",
                params: params
            })
            .success(function (response) {
                $scope.queried = true;
                if (response.success) {
                    $scope.application_list = response.data.application_list;
                    $scope.brand_list = response.data.brand_list;
                    $scope.product_list = response.data.product_list;

                    // } else {
                //     $scope.Tips.show(2000, response.message, null);
                }
            })
            .error(function (response, status) {
                $scope.Tips.show(2000, '网络不可用，请检查您的网络设置', function () {
                    // $scope.doRefresh();
                });
            })
            .finally(function() {
                $ionicLoading.hide();
            })
            ;
        };
    })

    .controller('PersonalController', function($scope, $stateParams, $ionicHistory, $sce, config) {
        $scope.loop.pauseAllLoop();
        $ionicHistory.clearHistory();

        $scope.iframe_src_url = '';
        $scope.share = function() {
            if (typeof cordova === 'undefined') {
                return;
            }

            if (typeof ShareSDKPlugin === 'undefined'){
                if (config.isApple){
                    $scope.iframe_src_url = $sce.trustAsResourceUrl('https://itunes.apple.com/cn/app/id'+config.appConfig.app_ios_bundle_id);
                }else{
                    $scope.Tips.show(2000, '请下载最新版.', null);
                }
                return;
            }

            cordova.exec(function (result) {
                $scope.Tips.show(2000, '分享成功.', null);
            }, function (error) {
                console.debug(error);
            }, "ShareSDK", "share", [config.appProduct.appConfig.app_name, '帮您借更便宜的钱',
                config.assets_img_domain + '/common/' + config.appProduct.appConfig.app_package + '.logo.png',
                'https://m.huijiekuan.com/?pkgname='+config.appProduct.appConfig.app_package
            ]);
        };
    })

    .controller('VerifyController', function($scope, $stateParams) {
        $scope.url = $stateParams.url;
        $scope.title = $scope.isValid($stateParams.title)?($stateParams.title):'下一步';
    })

    .controller('MoreController', function($scope, $stateParams) {
        $scope.callback = {};
        $scope.setAuthen = function(UserAuthen){
            $scope.callback = function(){
                UserAuthen.logout(UserAuthen.goTarget('index'));
                return true;
            };
        };
    })

    .controller('HelpController', function($scope, $ionicScrollDelegate) {
        $scope.scrollPage = function(name, direct){
            if (direct===-1){
                $ionicScrollDelegate.$getByHandle(name).scrollBottom(true);
            }else if (direct===1){
                $ionicScrollDelegate.$getByHandle(name).scrollTop(true);
            }
        };
    })

    .controller('WellcomeController', function($scope, $window, $http, $timeout, $cordovaSplashscreen, config) {
        $scope.wellcome = function(){
            $window.localStorage.setItem(config.WELLCOME_TOKEN_NAME, new Date().getTime());
            $scope.goUrl('index', {}, false, true);
        };

    })

    .controller('FeedbackController', function($scope, $http, $state, $ionicHistory, config) {
        $scope.feedback = {};
        $scope.feedback.total = 256;
        $scope.feedback.feedbacks = '';

        $scope.applyFeedbackUp = function(feedbacks){
            // $scope.feedbacks = feedbacks;
        };

        $scope.getToken(false);

        $scope.requesting = false;
        $scope.isDone = false;
        $scope.feedback.applyFeedback = function(UserAuthen){
            if (!$scope.isValid($scope.feedback.feedbacks)){
                $scope.Tips.show(1000, '请输入您的宝贵意见', null);
                return;
            }
            if ($scope.feedback.feedbacks.length>$scope.feedback.total){
                $scope.Tips.show(1000, '字数超长', null);
                return;
            }
            if ($scope.requesting || $scope.isDone){return false;}
            $scope.requesting = true;

            var params = {};
            params[config.TOKEN_NAME] = $scope.getToken(true);
            params.serial_id = UserAuthen.base.serial_id;
            params.content = $scope.feedback.feedbacks;
            params.client = config.client;
            params.app_product_key = config.app_product_key;

            $http({
                timeout: 10000,
                method: 'jsonp',
                url: config.data_domain + "/index.php/authen/feedback?callback=JSON_CALLBACK",
                params : params
            })
            .success(function(response) {
                $scope.getToken(response);
                if (response.success){
                    $scope.isDone = true;
                    $scope.Tips.show(1000, '感谢您的宝贵意见！', function(){$scope.doBack();});
                }else{
                    $scope.Tips.show(2000, response.message, null);
                }
            })
            .error(function(response, status) {
                $scope.Tips.show(2000, '网络不可用，请检查您的网络设置', function () {
                    // $scope.doRefresh();
                });
            })
            .finally(function() {
                $scope.requesting = false;
            })
            ;
        };
    })

;